﻿#!/perl/bin/perl
#
# player.pl 差し替え版 2010/6/2
# splite3 対応版 2009/9/25
#
# segwrapperの場所
use lib 'c:\perlrtmp\lib';

###############################################
use segwrapper; 
require 'define.pl';
use Time::Local;
use LWP::UserAgent;
use Win32::Process;
use Win32;
use Switch;
use DBI;

$packet_size = 4096;

if($ENV{'HTTP_USER_AGENT'} =~ /iphone|ipod/i){
	$brtype = 1;
	$Thumb = 0;
	$Caption = 0;
	$MP4Archiver = 0;
	$IkioiGraph = 0;
	$IkioiRes = 0;
}elsif($ENV{'HTTP_USER_AGENT'} =~ /ipad/i){
	$brtype = 1;
	$Caption = 0;
	$MP4Archiver = 0;
}elsif($ENV{'HTTP_USER_AGENT'} =~ /chrome/i){
	$brtype = 2;
}elsif($ENV{'HTTP_USER_AGENT'} =~ /firefox/i){
	$brtype = 3;
}elsif($ENV{'HTTP_USER_AGENT'} =~ /msie/i){
	$brtype = 4;
}elsif($ENV{'HTTP_USER_AGENT'} =~ /opera/i){
	if(($ENV{'HTTP_USER_AGENT'} =~ /windows ce/i) ||
	   ($ENV{'HTTP_USER_AGENT'} =~ /$WMdevice/i)){	# DoCoMo
		$brtype = 6;
		$RwIPOD = "";
		$Thumb = 0;
		$Caption = 0;
		$MP4Archiver = 0;
		$IkioiGraph = 0;
		$IkioiRes = 0;
	}else{
		$brtype = 5;
	}
}elsif($ENV{'HTTP_USER_AGENT'} =~ /playstation 3/i){
	$brtype = 7;
}elsif($ENV{'HTTP_USER_AGENT'} =~ /iris/i){
		$brtype = 8;
		$Thumb = 0;
		$Caption = 0;
		$MP4Archiver = 0;
		$IkioiGraph = 0;
		$IkioiRes = 0;
}else{
	$brtype = 0;
}

$ENV{'REQUEST_METHOD'} =~ tr/a-z/A-Z/;
if($ENV{'REQUEST_METHOD'} eq "POST"){
	read(STDIN, $omsgid, $ENV{'CONTENT_LENGTH'});
}else{
	$omsgid = $ENV{'QUERY_STRING'};
}
if ($omsgid eq '') {
	if ($ENV{'PATH_INFO'} ne '') {
		$omsgid = $ENV{'PATH_INFO'};
		$omsgid =~ s/\///g;
	}
}

if($omsgid =~ /cachename=([0-9]+)/){
	$cacheName = $1;
	if($omsgid =~ /bc/){
		@bcS = @bciS = ();
		@inputs = split(/&/, $omsgid);
		foreach (@inputs){
			($name, $value) = split(/=/);
			$value =~ tr/+//;
			$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
			$value =~ s/\r|\n/\n/g;
			$value =~ s/~!/ ~!/g;
			if($name eq "bc"){ push(@bcS, $value); }
			if($name eq "bci"){ $FBCI{$value} = 'i'; }
			foreach $mcb (@bcS) {
				unless($FBCI{$mcb}){ $FBCI{$mcb} = 'p'; }
 			}
		}
	}

	if($omsgid =~ /abort=(.*)$/){	#エンコード処理中断
		$AbortName = $mp4_folder . "\\" . $1 . '.abt';
		open(ABT, ">$AbortName"); close(ABT);
		sleep(3);
	}

	&nres("", $cacheName);
	exit(0);
}

($msgid, $mode, $fill) = split(/&/, $omsgid);
$msgid =~ s/[\x00-\x1F]//g;
($day,$st_tim,$ed_tim,$ch)=split("-",$msgid);
if (($day !~ /^\d{6,6}$/) || ($st_tim !~ /^\d{6,6}$/) || ($ed_tim !~ /^\d{6,6}$/) || ($ch !~ /^\d+$/)) {
	if($omsgid =~ /mode=10/){		# 文字列検索
		$outQuery = "mode=10&site=007&lhour=24&sort=d&shour=$startH&area=$my_area&category=$tcategory&template=result";
		@inputs = split(/&/, $omsgid);
		foreach (@inputs){
			($name, $value) = split(/=/);
			$value =~ tr/+//;
			$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
			$value =~ s/\r|\n/\n/g;
			$value =~ s/~!/ ~!/g;
			if($name eq "SDate"){ $outQuery .= "&sdate=" . $value; }
			if($name eq "Period"){ $value += 1; $outQuery .= "&ldate=" . $value; }
			if($name eq "Search"){
#				$value =~ s/(\W)/sprintf("%%%02X", unpack("C", $1))/eg;
				$outQuery .= "&key=$value";
			}
		}
		&nres($outQuery, "");
	}elsif($omsgid =~ /mode=20/){		# 文字列検索
		&nres($omsgid, "");
	}elsif($omsgid =~ /^mode=06/){				# 時間別番組表
		$omsgid =~ /sdate=([0-9]*)/; $tmpD = $1;
		$ntim = substr($tmpD, 0, 4) . '年' . substr($tmpD, 4, 2) . '月' . substr($tmpD, 6, 2) . '日';
		$ntim .= 'の番組表<br><a href="?"><span style="font-size:9pt;">本日の番組表へ</span></a>';
		$ntim .=$MESSAGE;
		&select();
	}elsif($omsgid =~ /^site/){	#IEPGから切り出して表示
	        $omsgid =~ /request=(\d{6}-\d{6}-\d{6}-)(\d{2})/;
		$chan = $2;
		$request = $1.$2;
		&get_epg_db($request);
		if($chan ne ""){
			$msgid = $omsgid;
			$btsname = $mp4_folder . "\\" . $request;
			$errname = $log_folder."\\".$request.".err";
			&streamdisp();
		}else{
			&htmlhead();
			print "IEPG Error!";
		}
	}else{						# 検索画面
	    $omsgid="mode=06&site=007&lhour=2&area=$my_area&category=$tcategory&template=top&arg=17";
	    $ntim .= '本日の番組表';
	    &select();
	}
	print "</body></HTML>";
	exit();
}

$request = $day."-".$st_tim."-".$ed_tim."-".$ch;
$btsname = $mp4_folder . "\\" . $request;
$errname = $log_folder."\\".$request.".err";
foreach $statmp (@iepg_chan){	# 放送局逆引き
	($m_ch, $dsta) = split(/:/, $statmp);
	if($m_ch eq $ch){
		@dstac = split(/\,/, $dsta);
		$sta = $dstac[0];
		last;
	}
}

if($mode =~ /abort/){	#エンコード処理中断
	open(ABT, ">$btsname.abt"); close(ABT);
	sleep(3);
	$omsgid =~ /abort=(.*)$/; $URI = '?' . $1;
	&logdisp();
}

unless($mode =~ /make/){	#MP4生成ではない
	&streamdisp();
}

$yy = substr($day,0,2); $mm = substr($day,2,2); $dd = substr($day,4,2);
$stday = "$yy/$mm/$dd";
$h = substr($st_tim,0,2); $m = substr($st_tim,2,2); $s = substr($st_tim,4,2);
$stim = "$h:$m:00";
$h = substr($ed_tim,0,2); $m = substr($ed_tim,2,2); $s = substr($ed_tim,4,2);
$etim = "$h:$m:00";

$|=1;
unless((-f "$errname") || (($mode =~ /makep/) && (-f "$btsname.mp4")) || (($mode =~ /make/) && (-f "$btsname$RwIPOD.mp4"))){
	unless(-f "$btsname.np"){
		unless(-f "$btsname.np99"){	# 順番待ち
			&htmlhead();
			print "<BODY>";
			print "<script>location.href='?$omsgid';</script>\n\n\n\n\n</body></html>";
			$PofPerl = $^X;
			if($mode =~ /makep/){
				$MkMode= 0;
			}else{
				$MkMode= 1;
			}
			Win32::Process::Create($ProcessObj, $PofPerl,"$PofPerl encode.pl $btsname $errname $stday $stim $etim $ch $MkMode", 0, DETACHED_PROCESS, ".");
			exit();
		}else{
			&logdisp("■他の番組を抽出中です。順番待ちをしています&nbsp;<a href=\"?$request&abort=$omsgid\">「中断」</a>");
		}
	}else{
		$Rmsg = &status_vs($btsname);
		&logdisp($Rmsg);
	}
}else{
	$Rmsg = &status_vs($btsname);
	if($Rmsg ne ""){
		&logdisp($Rmsg);
	}
	$omsgid =~ /make[p]*=(.*)$/; $URI = '?' . $1;
	&logdisp();
}

# ---------------------
sub status_vs {
	local($btsname, $sw) = @_;
	$retval = "";

	if(-f "$btsname.np98"){	#TS切り出し中
		$fiszts = (-s "$btsname.ts");
		$fiszts = int($fiszts / 1024 / 1024);
		$retval = "■ TSを抽出中です。<br>おまちください..<br>(TS/$fiszts\MBytes)";
	}elsif(-f "$btsname.np11"){
		$retval = "■ PC向け最終処理発行中です。<br>おまちください...";
	}elsif(-f "$btsname.np1"){
		$retval = "■ iPod向け最終処理発行中です。<br>おまちください...";
	}elsif(-f "$btsname.np2"){
		$fiszts = (-s "$btsname.wav");
		$fiszts = int($fiszts / 1024 / 1024);
		$retval = "■ iPod向けエンコード処理中です。<br>おまちください...<br>(音声/dec, WAV/$fiszts\MBytes)";
	}elsif(-f "$btsname.np21"){
		$fiszts = (-s "$btsname.aactmp");
		$fiszts = int($fiszts / 1024 / 1024);
		$retval = "■ iPod向けエンコード処理中です。<br>おまちください...<br>(音声/enc, AAC/$fiszts\MBytes)";
	}elsif(-f "$btsname.np22"){
		$fiszts = (-s "$btsname$RwIPOD.mp4");
		$fiszts = int($fiszts / 1024 / 1024);
		$retval = "■ iPod向けエンコード処理中です。<br>おまちください...<br>(映像/mrg, MP4/$fiszts\MBytes)";
	}elsif(-f "$btsname.np3"){
		$fiszor = (-s "$btsname.mp4");
		$fiszoj = (-s "$btsname$RwIPOD.mp4");
		$finp = int($fiszoj / $fiszor * 100);
		$retval = "■ iPod向けエンコード処理中です。<br>おまちください...<br>(映像/enc, PC用比/$finp\%)";
	}elsif(-f "$btsname.np4"){
		if(-f $btsname . "_tmp.mp4"){
			$fiszts = (-s $btsname . "_tmp.mp4");
			$fiszts = int($fiszts / 1024 / 1024);
			$pgm = "<br>(tmp/$fiszts\MBytes)";
		}elsif(-f $btsname . ".mp4"){
			$fiszor = (-s "$btsname.ts");
			$fiszoj = (-s "$btsname.mp4");
			$finp = int($fiszoj / $fiszor * 100);
			$pgm = "<br>(TS比/$finp\%)";
		}else{
			$pgm = "";
		}
		$retval = "■ TSをMP4に変換中です。<br>おまちください...$pgm";
	}
	if($retval ne ""){
		if($omsgid =~ /make[p]*=(.*)$/){
			$URIL = $1;
		}else{
			$URIL = $omsgid;
		}
		if($sw ne 'nouri'){
			$retval .= "&nbsp;<a href='?$request&abort=$URIL'><nobr>「中断」</nobr></a>";
		}
	}
	return $retval;

}

sub htmlhead {
	($vwid) = @_;
	if($vwid eq ""){ $vwid = 345; }
print "Content-type: text/html\n\n";
print <<"_EOD_";
<HTML>
<HEAD>
	<TITLE>TV:$request</TITLE>
_EOD_

	if(($brtype eq 1) || ($brtype eq 6) || ($brtype eq 8)){	# ipod, Opera mobile 9.5, WM iris.
		print "<meta name='viewport' content='width=$vwid' />\n";
	}
print <<"_EOD_";
	<meta http-equiv="Content-type" content="text/html; charset=utf-8">
	<style type="text/css">
	img {
	text-decoration: none;
	background: transparent;
	border: 0px none;
	vertical-align: bottom;
	}
	A { text-decoration:none;}
	A:hover { text-decoration:underline;}
	.nres {
		font-size: 9pt;
		line-height:1.2	;
	}
	.ttbl table {
		font-size: 9pt;
		table-layout:fixed;
		width:100%;
		border-collapse:collapse;
		border:1px solid #999999;
	}
	.ttbl td {
		border:1px solid #999999;
		overflow:hidden;
		vertical-align:top;
		line-height:1.2	;
	}
	.ttbl th {
		background-color: #CCE9FF;
		border:1px solid #999999;
		overflow:hidden;
		line-height:1.2	;
	}
	.bgAnime {
		background-color: #FDFDE2;
	}
	.bgDrama {
		background-color: #FDEEF1;
	}
	.bgMusic {
		background-color: #DEFAFE;
	}
	.bgSports {
		background-color: #DEFEEB;
	}
	.bgMovie {
		background-color: #FDE8CF;
	}
	.bgRecording {
		background-color: #EEEEEE;	
		color: #999999
	}
	.bgNone {
		background-color: #CCCCCC;	
		color: #999999
	}
	</style>
</HEAD>
_EOD_
}

# ---------------------
#   ログ表示
# ---------------------
sub logdisp {
	my $msg = shift;

	print "Content-type: text/html\n\n";
	print <<_EOD_;
<HTML>
<HEAD>
_EOD_
	if($URI ne ""){
		print "<META http-equiv='refresh' content='0;url=$URI'>\n";
	}else{
		print "<META http-equiv='refresh' content='$reload_time'>\n"
	}
	if(($brtype eq 1) || ($brtype eq 6) || ($brtype eq 8)){	# ipod, Opera mobile 9.5, WM iris.
		print "<meta name='viewport' content='width=320' />\n";
	}
	print <<_EOD_;
	<meta http-equiv="Content-type" content="text/html; charset=utf-8">
	<TITLE>TV:$request</TITLE>
</HEAD>
<BODY>
	$msg<BR>
</BODY>
</HTML>
_EOD_
	exit(0);
}


# ---------------------
#   動画ページ表示
# ---------------------
sub streamdisp {
	$TitleID = $TitleI;
	if($icon_enable){
	    $TitleID =~ s/\[(.*?)\]/<img src=\"img\/$title_icon{$1}\.gif\" width=\"13\" height=\"13\" alt=\"$1\">/g;
#	    $TitleSI =~ s/\【(.*?)\】/<img src=\"img\/$desc_icon{$1}\.gif\" width=\"13\" height=\"13\" alt=\"$1\">/g;
 	    &TitleSI_icon(\$TitleSI);	    
	} 
	$TitleSI =~ s/^▽//;
	$TitleSI =~ s/▽/\<br\>/g;
	if($omsgid =~ /down/){
			&streamdown;
	}else{
		if(($brtype eq 1) || ($brtype eq 6) || ($brtype eq 8)){	# ipod, Opera mobile 9.5, WM iris.
			&streamdisp_mobile;
		}else{
			if($OpenNewWindow eq 0){
				&streamdisp_pc;
			}else{
				&streamdisp_pcwo;
			}
		}
	}
}

sub streamdisp_mobile {
	$recok = &jg_recdate($request);
	if(($ShotE eq 1) && (-f $FFMpeg) && ($recok eq 1)){
		&get_shot($request);
	}
	&htmlhead();
	print <<"_EOD_";
<BODY>
<table border=1 bordercolor='#999999' cellspacing=0 cellpadding=3 style='font-size: 9pt;' id='mtbl'>
<tr><td bgcolor="#EEAAAA"><table border=0 cellpadding=0 cellspacing=0 width=100% style="font-size: 9pt;"><td>■
_EOD_
	if($sta ne ""){ print "$sta &nbsp;" }
	if($TitleI ne ""){ print "「$TitleI」"; }
	print "</td><td>&nbsp;</td><td align=right nowrap>\n";
	if($OpenNewWindow eq 0){
		print "<a href='?'>番組検索へ戻る</a>";
	}
	print <<"_EOD_";
</table></td></tr><tr><td>
_EOD_
	if($recok eq 1){
		if(-f "$ShotDir\\$request.jpg"){
			print "<img src='$jpg_URL$request.jpg'>\n";
		}else{
			print "<table border=0 width=320 height=180><td bgcolor='#000000'></td></table>";
		}
	}else{
		print "<table border=0 width=320 height=180><td bgcolor='#555555' align=center><font color='#ffffff'>録画が完了していない為、再生できません</font></td></table>";
	}
	print "<table border=0><td></td></table>\n";
	$bsTbl = "<table border=1 bordercolor='#999999' cellspacing=0 cellpadding=3 style='font-size: 9pt;' width=100%><tr><td bgcolor='#EECCCC'>";
 	if($TitleSI ne ""){ print "$bsTbl $TitleSI <br></td></table>";}
	if(($TitleSI ne "") && ($TitleSP ne "")){ print "<table border=0><td></td></table>\n"; } 
	if($TitleSP ne ""){ print "$bsTbl $TitleSP <br></td></table>";}
	print "<table border=0><td></td></table><table border=0 style='font-size: 9pt;'><td align=center>\n";
	$TitleIEnc = &mkFname($TitleI, $request, $sta);
	$Rmsg = &status_vs($btsname);
	($tmp1, $tmp2, $tmp3, $cht) = split(/-/, $request);
	if(-f "$errname"){
		print "■MP4作成に失敗しました";
	}elsif(-f "$btsname.np99"){
		print "■他の番組を抽出中です。順番待ちをしています&nbsp;<a href='?$request&abort=$omsgid'><nobr>「中断」</nobr></a>";
	}elsif($Rmsg ne ""){
		print $Rmsg;
	}elsif($recok eq -1){
		print "■現在録画中です";
	}elsif($recok eq -2){
		print "■まだ録画していません";
	}else{
		if((-f "$btsname$RwIPOD.mp4") && ($brtype eq 1)){
			$fisz = (-s "$btsname$RwIPOD.mp4");
			$fisz = int($fisz / 1024 / 1024);
			print "・MP4ファイルサイズ ($fisz MB)<br>";
			print "<nobr>&nbsp;&nbsp;&nbsp;<a href='download.pl?$request.mp4&$request$RwIPOD%2Emp4&$RwIPOD&oct'>ダウンロード</a>";
			print "&nbsp;&nbsp;&nbsp;<a href='$mp4_URL$request$RwIPOD.mp4'>MP4を再生する</a>";
		}elsif((-f "$btsname.mp4") && ($brtype eq 1)){
			$fisz = (-s "$btsname.mp4");
			$fisz = int($fisz / 1024 / 1024);
			print "・MP4ファイルサイズ ($fisz MB)<br>";
			print "<nobr>&nbsp;&nbsp;&nbsp;<a href='download.pl?$request.mp4&$request%2Emp4&&oct'>ダウンロード</a>";
			print "&nbsp;&nbsp;&nbsp;<a href='$mp4_URL$request.mp4'>MP4を再生する</a>";
		}elsif((-f "$btsname.mp4") && (($brtype eq 6) || ($brtype eq 8))){	# Opera Mobile, Iris
			$fisz = (-s "$btsname.mp4");
			$fisz = int($fisz / 1024 / 1024);
			print "・MP4ファイルサイズ ($fisz MB)<br>";
			print "<nobr>&nbsp;&nbsp;&nbsp;<a href='download.pl?$request.mp4&$TitleIEnc%2Emp4'>ダウンロード</a>";
			print "<nobr>&nbsp;&nbsp;&nbsp;<a href='download.pl?$request.bat&$request%2Emp4'>MP4を再生する</a>";
		}elsif(-f "$errname"){
			print "・MP4作成に失敗しました";
		}else{
			if(($brtype eq 1) && ($iencM{$cht} ne 0)){
				print "・<a href='?$request&make=$msgid'>MP4を作成</a>";
			}else{
				print "・<a href='?$request&makep=$msgid'>MP4を作成</a>";
			}
		}
	}
	print <<"_EOD_";
</td>
</table>
</div></td></tr></table>
</form>
</BODY>
</HTML>

_EOD_
	exit(0);
}

sub streamdisp_pc {
	$recok = &jg_recdate($request);
	if(($ShotE eq 1) && (-f $FFMpeg) && ($recok eq 1)){
		&get_shot($request);
	}
	&htmlhead();
	print <<"_EOD_";
<body>
<SCRIPT TYPE="text/javascript">
	function scale_chg(scid) {
		document.cookie  ="scgID=" + scid;
		location.href = "?$msgid"
	}
	var PgTmp = document.cookie;
	if(PgTmp == ""){ PgTmp = "scgID=1"; }
	PgTal = PgTmp.split("=");
	if(PgTal[1] == 3){
		var xw = 640;
		var yh = 380;
	}else if(PgTal[1] == 2){
		var xw = 480;
		var yh = 290;
	}else{
		var xw = 320;
		var yh = 200;
	}
	function playerReady(obj) {
		player = document.getElementById(obj['id']);
//		player.addControllerListener('ITEM', 'itemtest');
//		player.addModelListener('META', 'metatest');
		player.addModelListener('TIME', 'ntime');
	}
	function ntime(obj) { nowpos = obj.position; }

	function seekmv(dftime) {
		player.sendEvent('SEEK', nowpos + dftime);
	}


</script>
<table border=1 bordercolor='#999999' cellspacing=0 cellpadding=3 style='font-size: 9pt;' id='mtbl'>
<tr><td bgcolor="#EEAAAA"><table border=0 cellpadding=0 cellspacing=0 width=100% style="font-size: 9pt;"><td>■
_EOD_
	if($sta ne ""){ print "$sta &nbsp;" }
	if($TitleI ne ""){ print "「$TitleI」"; }
	print "</td><td>&nbsp;</td><td align=right nowrap>\n";
	if($OpenNewWindow eq 0){
		print "<a href='?'>番組検索へ戻る</a>";
	}
	print <<"_EOD_";
</td>
</table></td></tr><tr><td align=center>
_EOD_

	if($recok ne -2){
		print <<"_EOD_";
<form name='chgs'>
<script type="text/javascript" src="swfobject.js"></script>
<div id='preview'>This div will be replaced</div>
<script type="text/javascript">
	var s1 = new SWFObject('player44.swf','player', xw, yh,'9','#ffffff');
	s1.addParam('allowfullscreen','true');
	s1.addParam('allowscriptaccess','always');
_EOD_
		if($Caption eq 0){
			if(-f "$ShotDir\\$request.jpg"){
				print "s1.addParam('flashvars','file=$request.flv&streamer=rtmp://$ENV{'SERVER_NAME'}/vod&fullscreen=true&image=$jpg_URL$request.jpg&type=rtmp');\n";
			}else{
				print "s1.addParam('flashvars','file=$request.flv&streamer=rtmp://$ENV{'SERVER_NAME'}/vod&fullscreen=true&type=rtmp');\n";
			}
		}else{
			print "s1.addParam('flashvars','file=$request.flv&streamer=rtmp://$ENV{'SERVER_NAME'}/vod&fullscreen=true&plugins=captions-1&captions.file=caption.pl?file=$request.xml');\n"
		}
		print <<"_EOD_";
	s1.write('preview');
	document.write("<table border=0 width=100%><td bgcolor='#EECCCC' align=center>");
	document.write("<div style='font-size:9pt;'>画面サイズ変更：");
	document.write("<input name='r1' type='button' value='x1' style='width:50px;font-size:9pt;' ");
	if(PgTal[1] == 1){
		document.write("disabled>");
	}else{
		document.write("onclick='scale_chg(1);'>");
	}
	document.write("<input name='r2' type='button' value='x1.5' style='width:50px;font-size:9pt;' ");
	if(PgTal[1] == 2){
		document.write("disabled>");
	}else{
		document.write("onclick='scale_chg(2);'>");
	}
	document.write("<input name='r3' type='button' value='x2' style='width:50px;font-size:9pt;' ");
	if(PgTal[1] == 3){
		document.write("disabled>");
	}else{
		document.write("onclick='scale_chg(3);'>");
	}
</script>
</table>
<table border=0 width=100%>
<td bgcolor='#EE9999' align=center>
<input type="button" name="ds15" onclick="seekmv(-10);" value="-10秒" style='width:50px;font-size:9pt;'>
<input type="button" name="ST" onclick="player.sendEvent('STOP', true);" value="停止" style='width:45px;font-size:9pt;'>
<input type="button" name="pl" onclick="player.sendEvent('PLAY', true);" value="再生" style='width:45px;font-size:9pt;'>
<input type="button" name="s15" onclick="seekmv(10);" value="+10秒" style='width:50px;font-size:9pt;'>
<input type="button" name="s30" onclick="seekmv(30);" value="+30秒" style='width:50px;font-size:9pt;'>
<input type="button" name="cms" onclick="seekmv($CMSt);" value="CM送" style='width:50px;font-size:9pt;'>
</td>
</table>
_EOD_
	}else{
		print "<table border=0 width=320 height=180><td bgcolor='#555555' align=center><font color='#ffffff'>未来の番組は再生できません</font></td></table>";
	}
	print "<table border=0><td></td></table>";
	$bsTbl = "<table border=1 bordercolor='#999999' cellspacing=0 cellpadding=3 style='font-size: 9pt;' width=100%><tr><td bgcolor='#EECCCC'>";
	if($TitleSI ne ""){ print "$bsTbl $TitleSI <br></td></table>";}
	if(($TitleSI ne "") && ($TitleSP ne "")){ print "<table border=0><td></td></table>\n"; } 
	if($TitleSP ne ""){ print "$bsTbl $TitleSP <br></td></table>";}
	print "<table border=0><td></td></table><table border=0  cellpadding=0 cellspacing=2 style='font-size: 9pt;'><tr align=center valign=top><td>\n";
	$TitleIEnc = &mkFname($TitleI, $request, $sta);
	$Rmsg = &status_vs($btsname);
	($tmp1, $tmp2, $tmp3, $cht) = split(/-/, $request);
	if(-f "$errname"){
		print "■MP4作成に失敗しました<br>・<a href='download.pl?$request.ts&$TitleIEnc%2Ets'>TS Down</a>";
	}elsif(-f "$btsname.np99"){
		print "■他の番組を抽出中です。順番待ちをしています&nbsp;<a href='?$request&abort=$omsgid'><nobr>「中断」</nobr></a>";
	}elsif($Rmsg ne ""){
		print $Rmsg;
	}elsif($recok eq -1){
		print "■現在録画中です";
	}elsif($recok eq -2){
		print "■まだ録画していません";
	}else{
		if(-f "$btsname.mp4"){
			$fisz = (-s "$btsname.mp4");
			$fisz = int($fisz / 1024 / 1024);
			print "<nobr>・<a href='download.pl?$request.mp4&$TitleIEnc%2Emp4'>PC用MP4</nobr> <nobr>($fisz" . "MB)</nobr></a>";
		}else{
			print "・<a href='?$request&makep=$msgid'>PC用MP4作成</a>";
		}
		if($RwIPOD ne ""){
			print "</td><td width=5>&nbsp;</td><td>";
			if(-f "$btsname$RwIPOD.mp4"){
				$fisz = (-s "$btsname$RwIPOD.mp4");
				$fisz = int($fisz / 1024 / 1024);
				print "<nobr>・<a href='download.pl?$request.mp4&$TitleIEnc$RwIPOD%2Emp4&$RwIPOD'>iPod用MP4</nobr> <nobr>($fisz" . "MB)</nobr></a>";
			}elsif((-f "$btsname.mp4") && ($iencM{$cht} eq 0)){
				$fisz = (-s "$btsname.mp4");
				$fisz = int($fisz / 1024 / 1024);
				print "<nobr>・<a href='download.pl?$request.mp4&$TitleIEnc$RwIPOD%2Emp4'>iPod用MP4</nobr> <nobr>($fisz" . "MB)</nobr></a>";
			}elsif($iencM{$cht} eq 0){
				print "・<a href='?$request&makep=$msgid'>iPod用MP4作成</a>";
			}else{
				print "・<a href='?$request&make=$msgid'>iPod用MP4作成</a>";
			}
		}
		print <<"_EOD_";
</td><td width=5>&nbsp</td>
</td><td align=right nowrap>・<a href='download.pl?$request.ts&$TitleIEnc%2Ets'>TS Down</a></td>
_EOD_
		if($MP4Archiver eq 1){
			print <<"_EOD_";
</td><td width=5>&nbsp;</td>
<td align=right nowrap>・<a href='caption2.pl?file=$request.xml'>字幕生成</a></td>
_EOD_
		}
print "</tr>";
	}
	print <<"_EOD_";
</table>
</div></td></tr></table>
</form>
<script type="text/javascript">
document.getElementById('mtbl').style.width=xw + 14;
</script>
</BODY>
</HTML>

_EOD_
	exit(0);
}

sub streamdisp_pcwo {
	$recok = &jg_recdate($request);
	if(($ShotE eq 1) && (-f $FFMpeg) && ($recok eq 1)){
		&get_shot($request);
	}
	&htmlhead();
	if($brtype eq 2){		#Chrome
		$hA = 70;
		$xA = 16;
	}elsif($brtype eq 3){	#FireFox
		$hA = 95;
		$xA = 16;
	}elsif($brtype eq 4){	#IE
		$hA = 90;
		$xA = 10;
	}elsif($brtype eq 5){	#opera
		$hA = 85;
		$xA = 18;
	}else{
		$hA = 90;
		$xA = 15;
	}
	print <<"_EOD_";
<body marginheight=0 marginwidth=0 topmargin=0 leftmargin=0 rightmargin=0 OnLoad="resizewin();">
<center>
<SCRIPT TYPE="text/javascript">
	window.resizeTo(320,240);
	window.moveTo(0,0);
	var PgTmp = document.cookie;
	if(PgTmp == ""){ PgTmp = "scgID=1"; }
	PgTal = PgTmp.split("=");
	if(PgTal[1] == 3){
		var xw = 640;
		var yh = 380;
	}else if(PgTal[1] == 2){
		var xw = 480;
		var yh = 290;
	}else{
		var xw = 320;
		var yh = 200;
	}

	function playerReady(obj) {
		player = document.getElementById(obj['id']);
//		player.addControllerListener('ITEM', 'itemtest');
//		player.addModelListener('META', 'metatest');
		player.addModelListener('TIME', 'ntime');
	}
	function ntime(obj) { nowpos = obj.position; }

	function seekmv(dftime) {
		player.sendEvent('SEEK', nowpos + dftime);
	}

	function scale_chg(scid) {
		window.resizeTo(320,240);
		document.cookie  ="scgID=" + scid;
		location.href = "?$msgid"
	}

	function resizewin() {
		var yhi = document.body.scrollHeight;
		window.resizeTo(xw + $xA, yhi + $hA);
		window.focus();
	}

	document.write("<table border=0 cellpadding=3 cellspacing=0 width=" + xw + " style='font-size: 9pt;'><tr bgcolor='#EEAAAA'><td>■");
</script>
_EOD_
	if($sta ne ""){ print "$sta &nbsp;" }
	if($TitleI ne ""){ print "「$TitleI」"; }
	print <<"_EOD_";
</td><td width=5><form name='chgs'></td></tr>
</table>
_EOD_
	if($recok ne -2){
		print <<"_EOD_";
<script type="text/javascript" src="swfobject.js"></script>
<div id='preview'>This div will be replaced</div>
<script type="text/javascript">
	var s1 = new SWFObject('player44.swf','player', xw, yh, '9','#ffffff');
	s1.addParam('allowfullscreen','true');
	s1.addParam('allowscriptaccess','always');
_EOD_
		if($Caption eq 0){
			if(-f "$ShotDir\\$request.jpg"){
				print "s1.addParam('flashvars','file=$request.flv&streamer=rtmp://$ENV{'SERVER_NAME'}/vod&fullscreen=true&image=$jpg_URL$request.jpg');\n";
			}else{
				print "s1.addParam('flashvars','file=$request.flv&streamer=rtmp://$ENV{'SERVER_NAME'}/vod&fullscreen=true');\n";
			}
		}else{
			print "s1.addParam('flashvars','file=$request.flv&streamer=rtmp://$ENV{'SERVER_NAME'}/vod&fullscreen=true&plugins=captions-1&captions.file=caption.pl?file=$request.xml');\n"
		}
		print <<"_EOD_";


		print <<"_EOD_";
	s1.write('preview');
	document.write("<table border=0 width=" + xw + "><td bgcolor='#EECCCC' align=center>");
	document.write("<div style='font-size:9pt;'>画面サイズ変更：");
	document.write("<input name='r1' type='button' value='x1' style='width:50px;font-size:9pt;' ");
  	if(PgTal[1] == 1){
		document.write("disabled>");
	}else{
		document.write("onclick='scale_chg(1);'>");
	}
	document.write("<input name='r2' type='button' value='x1.5' style='width:50px;font-size:9pt;' ");
	if(PgTal[1] == 2){
		document.write("disabled>");
	}else{
		document.write("onclick='scale_chg(2);'>");
	}
	document.write("<input name='r3' type='button' value='x2' style='width:50px;font-size:9pt;' ");
	if(PgTal[1] == 3){
		document.write("disabled>");
	}else{
		document.write("onclick='scale_chg(3);'>");
	}
	document.write("</table><table border=0 width=" + xw + ">");

</script>
<td bgcolor='#EE9999' align=center>
<input type="button" name="ds15" onclick="seekmv(-10);" value="-10秒" style='width:50px;font-size:9pt;'>
<input type="button" name="ST" onclick="player.sendEvent('STOP', true);" value="停止" style='width:40px;font-size:9pt;'>
<input type="button" name="pl" onclick="player.sendEvent('PLAY', true);" value="再生" style='width:40px;font-size:9pt;'>
<input type="button" name="s15" onclick="seekmv(10);" value="+10秒" style='width:50px;font-size:9pt;'>
<input type="button" name="s30" onclick="seekmv(30);" value="+30秒" style='width:50px;font-size:9pt;'>
<input type="button" name="cms" onclick="seekmv($CMSt);" value="CM送" style='width:50px;font-size:9pt;'>
</td>
</table>
_EOD_
	}else{
		print "<table border=0 width=320 height=180><td bgcolor='#555555' align=center><font color='#ffffff'>未来の番組は再生できません</font></td></table>";
	}
	print "<table border=0><td></td></table>";
	$bsTbl = "<script>document.write(\"<table border=0 cellspacing=0 cellpadding=3 style='font-size: 9pt;' width=\" + xw +\"><tr><td bgcolor='#EECCCC'>\");</script>\n";
	if($TitleSI ne ""){ print "$bsTbl $TitleSI <br></td></table>";}
	if(($TitleSI ne "") && ($TitleSP ne "")){ print "<table border=0><td></td></table>\n"; } 
	if($TitleSP ne ""){ print "$bsTbl $TitleSP <br></td></table>";}
	print "<table border=0><td></td></table><table border=0 style='font-size: 9pt;'><td align=center>\n";
	$TitleIEnc = &mkFname($TitleI, $request, $sta);
	print "<table border=0><td></td></table><table border=0 cellpadding=0 cellspacing=2 style='font-size: 9pt;'><tr align=center valign=top><td>\n";
	$TitleIEnc = &mkFname($TitleI, $request, $sta);
	$recok = &jg_recdate($request);
	$Rmsg = &status_vs($btsname);
	($tmp1, $tmp2, $tmp3, $cht) = split(/-/, $request);
	if(-f "$errname"){
		print "■MP4作成に失敗しました<br>・<a href='download.pl?$request.ts&$TitleIEnc%2Ets'>TS Down</a>";
	}elsif(-f "$btsname.np99"){
		print "■他の番組を抽出中です。順番待ちをしています&nbsp;<a href='?$request&abort=$omsgid'><nobr>「中断」</nobr></a>";
	}elsif($Rmsg ne ""){
		print $Rmsg;
	}elsif($recok eq -1){
		print "■現在録画中です";
	}elsif($recok eq -2){
		print "■まだ録画していません";
	}else{
		if(-f "$btsname.mp4"){
			$fisz = (-s "$btsname.mp4");
			$fisz = int($fisz / 1024 / 1024);
			print "<nobr>・<a href='download.pl?$request.mp4&$TitleIEnc%2Emp4'>PC用MP4</nobr> <nobr>($fisz" . "MB)</nobr></a>";
		}else{
			print "・<a href='?$request&makep=$msgid'>PC用MP4作成</a>";
		}

		if($RwIPOD ne ""){
			print "</td><td width=5>&nbsp;</td><td>";
			if(-f "$btsname$RwIPOD.mp4"){
				$fisz = (-s "$btsname$RwIPOD.mp4");
				$fisz = int($fisz / 1024 / 1024);
				print "<nobr>・<a href='download.pl?$request.mp4&$TitleIEnc$RwIPOD%2Emp4&$RwIPOD'>iPod用MP4</nobr> <nobr>($fisz" . "MB)</nobr></a>";
			}elsif((-f "$btsname.mp4") && ($iencM{$cht} eq 0)){
				$fisz = (-s "$btsname.mp4");
				$fisz = int($fisz / 1024 / 1024);
				print "<nobr>・<a href='download.pl?$request.mp4&$TitleIEnc$RwIPOD%2Emp4'>iPod用MP4</nobr> <nobr>($fisz" . "MB)</nobr></a>";
			}elsif($iencM{$cht} eq 0){
				print "・<a href='?$request&makep=$msgid'>iPod用MP4作成</a>";
			}else{
				print "・<a href='?$request&make=$msgid'>iPod用MP4作成</a>";
			}
		}
		print <<"_EOD_";
</td><td width=5>&nbsp</td>
</td><td align=right nowrap>・<a href='download.pl?$request.ts&$TitleIEnc%2Ets'>TS Down</a></td>
_EOD_
		if($MP4Archiver eq 1){
			print <<"_EOD_";
</td><td width=5>&nbsp;</td>
<td align=right nowrap>・<a href='caption2.pl?file=$request.xml'>字幕生成</a></td>
_EOD_
		}
print "</tr>";
	}
print <<"_EOD_";
</td></tr>
</table>
</div></td></tr></table>
</form>
</BODY>
</HTML>

_EOD_
	exit(0);
}

# ---------------------
#   選択ページ表示
# ---------------------

sub select {
	&htmlhead("960");
	if($jsib eq 1){
		print "<BODY onLoad=\"setDateF();setDate();setGraph(dat);\">\n";
	}else{
		print "<BODY onLoad=\"setDateF();setDate();\">\n";
	}
	print <<_EOD_;
	<SCRIPT TYPE="text/javascript"> 
<!-- 
	var youbi = new Array("日","月","火","水","木","金","土");

	function setDateF() {
		var today,dat,i,y,m,d,c;
		document.req.Day.length = $start_date;
		today = new Date();
		for(i=0;i<$start_date;i++) {
			dat = new Date();
			dat.setDate(today.getDate()-i);
			y = ("0"+dat.getYear().toString()); y = y.substr(y.length-2,2);
			m = ("0"+(dat.getMonth()+1).toString()); m = m.substr(m.length-2,2);
			d = ("0"+dat.getDate().toString()); d = d.substr(d.length-2,2);
			b = youbi[dat.getDay()];
			document.req.Day.options[i].text  = '20'+y+'/'+m+'/'+d+'('+b+')';
			document.req.Day.options[i].value = y+m+d;
		}
	}

	function goPlay() {
		var req,h,h1,h2,st_h,st_m,ed_h,ed_m,today,bef,day,y,m,d,sh,sm,eh,em;
		
		today = new Date();
		if (document.req.Back.value == '') {
			st_h = (document.req.Hour.value-0);
			st_m = (document.req.Min.value-0);
			ed_h = (document.req.Hour2.value-0);
			ed_m = (document.req.Min2.value-0);
			day  = document.req.Day.value;
		} else {
			bef = new Date();
			bef.setMinutes(today.getMinutes()-(document.req.Back.value-0));
			st_h = bef.getHours();
			st_m = bef.getMinutes();
			ed_h = today.getHours();
			ed_m = today.getMinutes();
			y = ("0"+bef.getYear().toString()); y = y.substr(y.length-2,2);
			m = ("0"+(bef.getMonth()+1).toString()); m = m.substr(m.length-2,2);
			d = ("0"+bef.getDate().toString()); d = d.substr(d.length-2,2);
			day  = y+m+d;
		}
		sh = ("0"+st_h.toString()); sh = sh.substr(sh.length-2,2);
		sm = ("0"+st_m.toString()); sm = sm.substr(sm.length-2,2);
		eh = ("0"+ed_h.toString()); eh = eh.substr(eh.length-2,2);
		em = ("0"+ed_m.toString()); em = em.substr(em.length-2,2);

		h1 = st_h*60+st_m;
		h2 = ed_h*60+ed_m;
		if (h1 == h2) {
			alert("開始時間と終了時間が同一です");
			return false;
		}
		h = h2 - h1;
		if (h<0) { h += 24*60; }
		if (h>(3*60)) {
			alert("一度の抽出時間は３時間までにしてください");
			return false;
		}
_EOD_
	if($OpenNewWindow eq 1){
		print "	req = '" . $cginame. "\?'+day+'-'+sh+sm+'00-'+eh+em+'00-'+document.req.Channel.value;\n";
		print "var wo = window.open(req, 'view_w', 'toolbar=no,directories=no,scrollbars=no,resizable=no,menubar=no,width=320,height=240');wo.resizeTo(320,240);wo.focus();\n";
	}else{
		print "	req = day+'-'+sh+sm+'00-'+eh+em+'00-'+document.req.Channel.value;\n";
		print "location.search = req;\n";
	}
	print <<_EOD_;
		return false;
	}

	function dispDate() {
		var dnum,dir,dat,dat2,y,m,d;

		dnum = document.days.Period.options[document.days.Period.selectedIndex].value;
		dir = document.days.Order.options[document.days.Order.selectedIndex].value;

		dat = new Date();
		dat.setTime(document.days.Day.options[document.days.Day.selectedIndex].value);
		dat2 = new Date();
		dat2.setTime(document.days.Day.options[document.days.Day.selectedIndex].value);
		if(dir==0) {
			dat.setDate(dat.getDate()-dnum);
		} else {
			dat2.setDate(dat2.getDate()+eval(dnum));
		}
		y = dat.getYear(); if(y < 1900){ y += 1900; }
		y = ("0"+y.toString()); y = y.substr(y.length-4,4);
		m = ("0"+(dat.getMonth()+1).toString()); m = m.substr(m.length-2,2);
		d = ("0"+dat.getDate().toString()); d = d.substr(d.length-2,2);
		document.days.SDate.value = y+m+d;

		y = dat2.getYear(); if(y < 1900){ y += 1900; }
		y = ("0"+y.toString()); y = y.substr(y.length-4,4);
		m = ("0"+(dat2.getMonth()+1).toString()); m = m.substr(m.length-2,2);
		d = ("0"+dat2.getDate().toString()); d = d.substr(d.length-2,2);
		document.days.EDate.value = y+m+d;

	}

	function setDate() {
		var today,dat,i,y,m,d,b;
		document.days.Day.length = $start_date;
		today = new Date();
		for(i=0;i<$start_date;i++) {
			dat = new Date();
			dat.setDate(today.getDate()-i);
			y = dat.getYear(); if(y < 1900){ y += 1900; }
			y = ("0"+y.toString()); y = y.substr(y.length-4,4);
			m = ("0"+(dat.getMonth()+1).toString()); m = m.substr(m.length-2,2);
			d = ("0"+dat.getDate().toString()); d = d.substr(d.length-2,2);
			b = youbi[dat.getDay()];
			document.days.Day.options[i].text  = y+'/'+m+'/'+d+'('+b+')';
			document.days.Day.options[i].value = dat.getTime();
		}
		dispDate();
	}

	function goNikkan2() {
		var code,genre,first,i,dnum,area,url;
_EOD_
  	if($TTSrhE eq 0){
		print <<_EOD_;
		code = new Array("B.","C.","D.","E.","F.","G.","H.","I.","J.","K.","L.","M.","BA","BB","BC","CA","CB","CC","DE","D2","D1","D4","D3","DI","EB","EA","ED","FA","FB","FE","FF","FG","FH","G1","G2","G3","MA","MB","MC","MD","ME","MI","IA","IB","IC","JA","JB","JD","JE","JH","JI","KA","KF","KH","HA","HI","HJ");
_EOD_
	}else{
		print <<_EOD_;
		code = new Array("B.","C.","D.","E.","F.","G.","H.","I.","J.","K.","L.","M.");
_EOD_
	}
	print <<_EOD_;
		first = true;
		genre = "";
		for(i=0;i<code.length;i++) {
			if( document.gens.elements["myCHK"+i].checked ) {
				if(first) {
					first = false;
				} else {
					genre += "|";
				}
				genre += code[i];
			}
		}

		dnum = eval(document.days.Period.options[document.days.Period.selectedIndex].value)+1;
		area = ("00"+"$my_area"); area = area.substr(area.length-3,3);
		url = "?mode=20&site=007&sort=d&sdate="+document.days.SDate.value+"&shour=05&lhour=24&area="+area+"&ldate="+dnum+"&genre="+genre+"&template=result&category=$category";
		location.href = url;
		return false;
	}

	function click_day(stday) {
		var area;
		area = ("00"+"$my_area"); area = area.substr(area.length-3,3);
		location.href="?mode=06&site=007&category=$tcategory&area=" + area + "&template=time&sdate=" + stday + "&lhour=24&shour=$startH&arg=12";
	}

	function chkE(cobj) {
		var ce;
		eval("ce = document.gens." + cobj + ".checked;");
		if(ce == true){
			eval("document.gens." + cobj + ".checked = false;");
		}else{
			eval("document.gens." + cobj + ".checked = true;");
		}
		return false;
	}
// -->
	</SCRIPT>
<table border=1 bordercolor='#999999' cellspacing=0 cellpadding=3 style="font-size: 9pt;" width=100%>
<tr><td bgcolor="#EEAAAA">■番組検索
_EOD_
	if($MP4Archiver eq 1){
		print "/<a href='./archives.pl'>mp4アーカイバ</a>";
	}

print <<_EOD_;
</td></tr>
<tr><td>
<br><b>・時間別番組表\から直接選択して抽出</b><br>
_EOD_

for($ci=1; $ci>-7; $ci--){
	$cVCal{$ci} = &MakeCal($ci);
}

$calDis = <<_EOS_;
<table border=0 width=100%>
<tr valign="top">
<td>$cVCal{-2}</td>
<td>$cVCal{-1}</td>
<td>$cVCal{0}</td>
<td>$cVCal{1}</td>
<td valign=middle align=center width=90% rowspan=2><span style='font-size:24pt;'>$ntim</span></td>
</tr>
<tr valign="top">
<td>$cVCal{'-6'}</td>
<td>$cVCal{'-5'}</td>
<td>$cVCal{'-4'}</td>
<td>$cVCal{'-3'}</td>
</tr>
</table>
_EOS_
	print $calDis;

	&ttnres($omsgid);
	if($MoreCal eq 1){ print $calDis; }
	print <<_EOD_;
<FORM NAME="req" onSubmit="return goPlay()" style="font-size:9pt;">
<hr>
<br><b>・時間を指定して番組抽出</b><br>
	<SELECT NAME="Day" style="font-size:9pt;">
	</SELECT>
	<SELECT NAME="Channel" style="font-size:9pt;">
_EOD_

	foreach $chanTmp (@iepg_chan){
		($ChanObj, $stations) = split(/:/, $chanTmp);
		@stationS = split(/\,/, $stations);
		$station = shift(@stationS);
		print "<OPTION VALUE=\"$ChanObj\">$station</OPTION>\n";
	}
	print <<_EOD_;
	</SELECT>
	<SELECT NAME="Hour" style="font-size:9pt;">
		<OPTION VALUE="00">00</OPTION>
		<OPTION VALUE="01">01</OPTION>
		<OPTION VALUE="02">02</OPTION>
		<OPTION VALUE="03">03</OPTION>
		<OPTION VALUE="04">04</OPTION>
		<OPTION VALUE="05">05</OPTION>
		<OPTION VALUE="06">06</OPTION>
		<OPTION VALUE="07">07</OPTION>
		<OPTION VALUE="08">08</OPTION>
		<OPTION VALUE="09">09</OPTION>
		<OPTION VALUE="10">10</OPTION>
		<OPTION VALUE="11">11</OPTION>
		<OPTION VALUE="12">12</OPTION>
		<OPTION VALUE="13">13</OPTION>
		<OPTION VALUE="14">14</OPTION>
		<OPTION VALUE="15">15</OPTION>
		<OPTION VALUE="16">16</OPTION>
		<OPTION VALUE="17">17</OPTION>
		<OPTION VALUE="18">18</OPTION>
		<OPTION VALUE="19">19</OPTION>
		<OPTION VALUE="20">20</OPTION>
		<OPTION VALUE="21">21</OPTION>
		<OPTION VALUE="22">22</OPTION>
		<OPTION VALUE="23">23</OPTION>
	</SELECT>
	:
	<SELECT NAME="Min" style="font-size:9pt;">
		<OPTION VALUE="00">00</OPTION>
		<OPTION VALUE="05">05</OPTION>
		<OPTION VALUE="10">10</OPTION>
		<OPTION VALUE="15">15</OPTION>
		<OPTION VALUE="20">20</OPTION>
		<OPTION VALUE="25">25</OPTION>
		<OPTION VALUE="30">30</OPTION>
		<OPTION VALUE="35">35</OPTION>
		<OPTION VALUE="40">40</OPTION>
		<OPTION VALUE="45">45</OPTION>
		<OPTION VALUE="50">50</OPTION>
		<OPTION VALUE="55">55</OPTION>
	</SELECT>
	〜
	<SELECT NAME="Hour2" style="font-size:9pt;">
		<OPTION VALUE="00">00</OPTION>
		<OPTION VALUE="01">01</OPTION>
		<OPTION VALUE="02">02</OPTION>
		<OPTION VALUE="03">03</OPTION>
		<OPTION VALUE="04">04</OPTION>
		<OPTION VALUE="05">05</OPTION>
		<OPTION VALUE="06">06</OPTION>
		<OPTION VALUE="07">07</OPTION>
		<OPTION VALUE="08">08</OPTION>
		<OPTION VALUE="09">09</OPTION>
		<OPTION VALUE="10">10</OPTION>
		<OPTION VALUE="11">11</OPTION>
		<OPTION VALUE="12">12</OPTION>
		<OPTION VALUE="13">13</OPTION>
		<OPTION VALUE="14">14</OPTION>
		<OPTION VALUE="15">15</OPTION>
		<OPTION VALUE="16">16</OPTION>
		<OPTION VALUE="17">17</OPTION>
		<OPTION VALUE="18">18</OPTION>
		<OPTION VALUE="19">19</OPTION>
		<OPTION VALUE="20">20</OPTION>
		<OPTION VALUE="21">21</OPTION>
		<OPTION VALUE="22">22</OPTION>
		<OPTION VALUE="23">23</OPTION>
	</SELECT>
	:
	<SELECT NAME="Min2" style="font-size:9pt;">
		<OPTION VALUE="00">00</OPTION>
		<OPTION VALUE="05">05</OPTION>
		<OPTION VALUE="10">10</OPTION>
		<OPTION VALUE="15">15</OPTION>
		<OPTION VALUE="20">20</OPTION>
		<OPTION VALUE="25">25</OPTION>
		<OPTION VALUE="30">30</OPTION>
		<OPTION VALUE="35">35</OPTION>
		<OPTION VALUE="40">40</OPTION>
		<OPTION VALUE="45">45</OPTION>
		<OPTION VALUE="50">50</OPTION>
		<OPTION VALUE="55">55</OPTION>
	</SELECT>
	を抽出、または今から
	<SELECT NAME="Back" style="font-size:9pt;">
		<OPTION VALUE="">--</OPTION>
		<OPTION VALUE="05">05</OPTION>
		<OPTION VALUE="10">10</OPTION>
		<OPTION VALUE="15">15</OPTION>
		<OPTION VALUE="20">20</OPTION>
		<OPTION VALUE="25">25</OPTION>
		<OPTION VALUE="30">30</OPTION>
		<OPTION VALUE="35">35</OPTION>
		<OPTION VALUE="40">40</OPTION>
		<OPTION VALUE="45">45</OPTION>
		<OPTION VALUE="50">50</OPTION>
		<OPTION VALUE="55">55</OPTION>
	</SELECT>分前を
	<INPUT TYPE="submit" VALUE="探す！" style="font-size:9pt;">
</FORM>
<FORM NAME="days" style="font-size:9pt;" method="get" action="$cginame">
<hr>
<br>
<b>・番組表から検索して抽出</b><br>
<table border=0 cellpadding=0 cellspacing=0 style="font-size:9pt;">
<td>
	<INPUT TYPE="hidden" NAME="mode" VALUE="10">
	<SELECT NAME="Day" onChange="dispDate()" style="font-size:9pt;">
	</SELECT>
から
	<SELECT NAME="Period" onChange="dispDate()" style="font-size:9pt;">
		<OPTION VALUE="2" >3日間</OPTION>
		<OPTION VALUE="6">1週間</OPTION>
		<OPTION VALUE="13">2週間</OPTION>
		<OPTION VALUE="20">3週間</OPTION>
		<OPTION VALUE="27">4週間</OPTION>
		<OPTION VALUE="34" SELECTED>5週間</OPTION>
	</SELECT>
	<SELECT NAME="Order" onChange="dispDate()" style="font-size:9pt;">
		<OPTION VALUE="0">前</OPTION>
		<OPTION VALUE="1">後</OPTION>
	</SELECT>
までの範囲を、キーワード
	<INPUT TYPE="hidden" NAME="SDate" READONLY>
	<INPUT TYPE="hidden" NAME="EDate" READONLY>
	<INPUT TYPE="text" NAME="Search" SIZE=20 style="font-size:9pt;">で<INPUT TYPE="submit" VALUE="検索" style="font-size:9pt;">
</td><td></FORM></td>
<td><FORM NAME="gens" onSubmit="return goNikkan2()" style="font-size:9pt;"></td>
</table>
	または、上記の日付の範囲で、以下のジャンルを<INPUT TYPE="submit" VALUE="抽出" style="font-size:9pt;"><br>
_EOD_

	if($TTSrhE eq 0){
		print <<_EOD_;
<table border=0 cellpadding=0 cellspacing=1 style="font-size:8pt;" width=500>
		<TR>
			<TD bgcolor="#EEAAAA"><INPUT TYPE="checkbox" NAME="myCHK5" ><B>バラエティ</B></TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK33">お笑い</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK34">クイズ</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK35">トーク</TD>
			</TD>
		</TR>
		<TR>
			<TD bgcolor="#EEAAAA"><INPUT TYPE="checkbox" NAME="myCHK0" ><B>ドラマ</B></TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK12">国内ドラマ</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK13">海外ドラマ</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK14">時代劇</TD>
		</TR>
		<TR>
			<TD bgcolor="#EEAAAA"><INPUT TYPE="checkbox" NAME="myCHK1" ><B>映画</B></TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK15">洋画</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK16">邦画</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK17">アニメ映画</TD>
		</TR>
		<TR>
			<TD bgcolor="#EEAAAA"><INPUT TYPE="checkbox" NAME="myCHK7" ><B>アニメ・特撮</B></TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK42">国内アニメ</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK43">海外アニメ</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK44">特撮・ヒーロー</TD>
		</TR>
		<TR>
			<TD ROWSPAN=2 bgcolor="#EEAAAA"><INPUT TYPE="checkbox" NAME="myCHK11"><B>ドキュメンタリー</B></TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK36">社会・時事</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK37">歴史・紀行</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK38">自然・動物・環境</TD>
		</TR>
		<TR>
			<TD><INPUT TYPE="checkbox" NAME="myCHK39">宇宙・科学・医学</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK40">カルチャー・伝統文化</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK41">インタビュー・討論</TD>
		</TR>
		<TR>
			<TD bgcolor="#EEAAAA"><INPUT TYPE="checkbox" NAME="myCHK6" ><B>趣味・教育</B></TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK54">旅・釣り・アウトドア</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK55">車・オートバイ</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK56">コンピュータ・TVゲーム</TD>
		</TR>
		<TR>
			<TD bgcolor="#EEAAAA"><INPUT TYPE="checkbox" NAME="myCHK9" ><B>情報・ワイドショー</B></TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK51">芸能・ワイドショー</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK52">グルメ</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK53">情報番組</TD>
		</TR>
		<TR>
			<TD ROWSPAN=2 bgcolor="#EEAAAA"><INPUT TYPE="checkbox" NAME="myCHK8" ><B>ニュース・報道</B></TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK45">定時総合ニュース</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK46">天気</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK47">経済・市況</TD>
		</TR>
		<TR>
			<TD><INPUT TYPE="checkbox" NAME="myCHK48">海外・国際</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK49">報道特番</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK50">ローカル・地域ニュース</TD>
		</TR>
		<TR>
			<TD bgcolor="#EEAAAA"><INPUT TYPE="checkbox" NAME="myCHK3" ><B>劇場・公演</B></TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK24">落語・演芸</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK25">歌舞伎・古典</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK26">ミュージカル</TD>
		</TR>
		<TR>
			<TD ROWSPAN=2 bgcolor="#EEAAAA"><INPUT TYPE="checkbox" NAME="myCHK4" ><B>音楽</B></TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK27">国内ロック・ポップス</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK28">海外ロック・ポップス</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK29">歌謡曲・演歌</TD>
		</TR>
		<TR>
			<TD><INPUT TYPE="checkbox" NAME="myCHK30">ライブ・コンサート</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK31">ランキング・リクエスト</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK32">カラオケ・のど自慢</TD>
		</TR>
		<TR>
			<TD ROWSPAN=2 bgcolor="#EEAAAA"><INPUT TYPE="checkbox" NAME="myCHK2" ><B>スポーツ</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK18">スポーツニュース</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK19">野球</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK20">サッカー</TD>
		</TR>
		<TR>
			<TD><INPUT TYPE="checkbox" NAME="myCHK21">相撲</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK22">ゴルフ</TD>
			<TD><INPUT TYPE="checkbox" NAME="myCHK23">競馬</TD>
		</TR>
		<TR>
			<TD colspan=4 bgcolor="#EEAAAA"><INPUT TYPE="checkbox" NAME="myCHK10"><B>福祉</B></TD>
		</TR>
_EOD_

	}else{
		print <<_EOD_;
<table border=0 cellpadding=2 cellspacing=0 style="font-size:8pt;" width=100%>
		<TR onMOuseOver='this.style.backgroundColor="#BBBBEE";' onMOuseOut='this.style.backgroundColor="#EEAAAA";' bgcolor="#EEAAAA">
			<TD width=10><INPUT TYPE="checkbox" NAME="myCHK5"></TD>
			<TD OnClick='chkE("myCHK5");' width=99%><B>バラエティ</B></TD>
		</TR>
		<TR onMOuseOver='this.style.backgroundColor="#BBBBEE";' onMOuseOut='this.style.backgroundColor="#EECCCC";' bgcolor="#EECCCC">
			<TD><INPUT TYPE="checkbox" NAME="myCHK0"></TD>
			<TD OnClick='chkE("myCHK0");'><B>ドラマ</B></TD>
		</TR>
		<TR onMOuseOver='this.style.backgroundColor="#BBBBEE";' onMOuseOut='this.style.backgroundColor="#EEAAAA";' bgcolor="#EEAAAA">
			<TD><INPUT TYPE="checkbox" NAME="myCHK1"></TD>
			<TD OnClick='chkE("myCHK1");'><B>映画</B></TD>
		</TR>
		<TR onMOuseOver='this.style.backgroundColor="#BBBBEE";' onMOuseOut='this.style.backgroundColor="#EECCCC";' bgcolor="#EECCCC">
			<TD><INPUT TYPE="checkbox" NAME="myCHK7"></TD>
			<TD OnClick='chkE("myCHK7");'><B>アニメ・特撮</B></TD>
		</TR>
		<TR onMOuseOver='this.style.backgroundColor="#BBBBEE";' onMOuseOut='this.style.backgroundColor="#EEAAAA";' bgcolor="#EEAAAA">
			<TD><INPUT TYPE="checkbox" NAME="myCHK11"></TD>
			<TD OnClick='chkE("myCHK11");'><B>ドキュメンタリー</B></TD>
		</TR>
		<TR onMOuseOver='this.style.backgroundColor="#BBBBEE";' onMOuseOut='this.style.backgroundColor="#EECCCC";' bgcolor="#EECCCC">
			<TD><INPUT TYPE="checkbox" NAME="myCHK6"></TD>
			<TD OnClick='chkE("myCHK6");'><B>趣味・教育</B></TD>
		</TR>
		<TR onMOuseOver='this.style.backgroundColor="#BBBBEE";' onMOuseOut='this.style.backgroundColor="#EEAAAA";' bgcolor="#EEAAAA">
			<TD><INPUT TYPE="checkbox" NAME="myCHK9"></TD>
			<TD OnClick='chkE("myCHK9");'><B>情報・ワイドショー</B></TD>
		</TR>
		<TR onMOuseOver='this.style.backgroundColor="#BBBBEE";' onMOuseOut='this.style.backgroundColor="#EECCCC";' bgcolor="#EECCCC">
			<TD><INPUT TYPE="checkbox" NAME="myCHK8"></TD>
			<TD OnClick='chkE("myCHK8");'><B>ニュース・報道</B></TD>
		</TR>
		<TR onMOuseOver='this.style.backgroundColor="#BBBBEE";' onMOuseOut='this.style.backgroundColor="#EEAAAA";' bgcolor="#EEAAAA">
			<TD><INPUT TYPE="checkbox" NAME="myCHK3"></TD>
			<TD OnClick='chkE("myCHK3");'><B>劇場・公演</B></TD>
		</TR>
		<TR onMOuseOver='this.style.backgroundColor="#BBBBEE";' onMOuseOut='this.style.backgroundColor="#EECCCC";' bgcolor="#EECCCC">
			<TD><INPUT TYPE="checkbox" NAME="myCHK4"></TD>
			<TD OnClick='chkE("myCHK4");'><B>音楽</B></TD>
		</TR>
		<TR onMOuseOver='this.style.backgroundColor="#BBBBEE";' onMOuseOut='this.style.backgroundColor="#EEAAAA";' bgcolor="#EEAAAA">
			<TD><INPUT TYPE="checkbox" NAME="myCHK2"></TD>
			<TD OnClick='chkE("myCHK2");'><B>スポーツ</TD>
		</TR>
		<TR onMOuseOver='this.style.backgroundColor="#BBBBEE";' onMOuseOut='this.style.backgroundColor="#EECCCC";' bgcolor="#EECCCC">
			<TD><INPUT TYPE="checkbox" NAME="myCHK10"></TD>
			<TD OnClick='chkE("myCHK10");'><B>福祉</B></TD>
		</TR>
_EOD_
	}
		print <<_EOD_;
</table>
</FORM>
</td></tr></table>

_EOD_
}

sub expire_file {
	($objdir, $objext, $lockf, $Expire) = @_;
	$locktrue = 1;
	if($lockf ne 'NoLock'){
		open(LK, ">$log_folder\\$lockf");
		unless(flock(LK, 6)){ $locktrue = 0; }
	}
	if($locktrue eq 1){
		opendir(DIB,"$objdir");
		while($DirObj = readdir(DIB)){
			if(($objext eq '*') || ($DirObj =~ /$objext$/)){
					@retval = stat("$objdir\\$DirObj");
					if($retval[9] < (time - $Expire)){
					unlink("$objdir\\$DirObj");
				}
			}
		}
		closedir(DIB);
		if($lockf ne 'NoLock'){	close(LK); }
	}
}

sub cache_write {
	($wrtBuf, $lockf, $CFName) = @_;
	open(LK, ">$log_folder\\$lockf");
	if(flock(LK, 6)){
		if(open(OUC, ">$CFName")){
			print OUC $wrtBuf;
			close(OUC);
		}
		close(LK);
	}
}

sub read_cache {
	($CFName, $lockf) = @_;
	local($RecB);
	$RecB = "";
	open(LK, ">$log_folder\\$lockf");
	if(flock(LK, 6)){
		if(open(INC, $CFName)){
			while(<INC>){ $RecB .= $_; }
			close(INC);
		}
		close(LK);
	}
	return $RecB;
}

sub jg_recdate {
	local($dtF) = @_;
	local($day, $st_tim, $ed_tim);
	($day, $st_tim, $ed_tim) = split(/-/, $dtF);
	$yy = substr($day,0,2); $mm = substr($day,2,2); $dd = substr($day,4,2);
	$h = substr($st_tim,0,2); $m = substr($st_tim,2,2); $s = substr($st_tim,4,2);
	$stimmin = $h * 3600 + $m * 60;
	$h = substr($ed_tim,0,2); $m = substr($ed_tim,2,2); $s = substr($ed_tim,4,2);
	$etimmin = $h * 3600 + $m * 60;
	if($stimmin > $etimmin){
		$lapt = 86400 + $etimmin;
	}else{
		$lapt = $etimmin;
	}
	$fot = timelocal(0,0,0,$dd, $mm - 1, $yy);
	$fot = $fot + $lapt;
	$nt = time;

	if($fot > $nt){
		return -1;
	}else{
		return 1;
	}
}
 
sub mkFname {
	local($TitleIs, $request_s, $sta_s) = @_;
	if($TitleIs =~ /\\|\/|:|\*|\"\<|\>|\||/){
		$TitleIs =~ s/\\|\/|:|\*|\"\<|\>|\||//g;
	}
	if($TitleIs eq ""){
		$TitleIs = $request_s;
	}else{
		$TitleIs = substr($request_s, 0, 6) . '-' . $sta_s . "「$TitleIs」";
	}
	$TitleIs =~ s/(\W)/sprintf("%%%02X", unpack("C", $1))/eg;
	return $TitleIs;
}

sub get_shot {
	local($requestl) = @_;
	($stdayT, $stimT, $Filler, $chl) = split(/-/, $requestl);
	$requestl = "$ShotDir\\$requestl";
	$stdayl = substr($stdayT, 0, 6);
	$h = substr($stimT, 0, 2); $m = substr($stimT, 2, 2);
	$stiml = "$h$m" . '05';
	$etiml = "$h$m" . '55';
	unless(-f "$requestl.jpg"){
		open(CL, ">$requestl.jpg"); close(CL);
		&expire_file($ShotDir, '*', 'nowlockS', $ExpireShot * 86400);
		$file = $stdayl . "-" . $stiml . "-" .  $etiml . "-" . $chl;
		$opt = O_RDONLY | O_BINARY;
		eval { $opt |= O_LARGEFILE; };
		if(open(OTS, ">$requestl.ts")){
			binmode(OTS);
			segwrapper::segopen($handle, $file, $opt);
			while(segwrapper::segread($handle, my $buf, $packet_size)) {
				print OTS $buf;
			}
			segwrapper::segclose($handle);
			close(OTS);
		}
		$fiszts = (-s "$requestl.ts");
		if($fiszts > 0){
			open(IN, "$FFMpeg -y -i $requestl.ts -ss $ShotS -b 128 -vframes 1 -s 320x180 -an $requestl.jpg |");
			while(<IN>){ print;}
			close(IN);
		}else{
			unlink "$requestl.jpg";
		}
		unlink "$requestl.ts";
	}
}

sub MakeCal {
	local($MonSw) = @_;
	@youbi = ('日','月','火','水','木','金','土');
	@WeekDayM = (
		'-1,0,0,-1,',
		'-1,0,0,-1,',
		'-1,1,1,-1,元旦',
		'-1,1,-1,2,成人の日',
		'-1,2,11,-1,建国記念日',
		'-1,4,29,-1,昭和の日',
		'-1,5,3,-1,憲法記念日',
		'-1,5,4,-1,みどりの日',
		'-1,5,5,-1,こどもの日',
		'-1,7,-1,3,海の日',
		'-1,9,-1,3,敬老の日',
		'-1,10,-1,2,体育の日',
		'-1,11,3,-1,文化の日',
		'-1,11,23,-1,勤労感謝の日',
		'-1,12,23,-1,天皇誕生日'
	);

	$ChkDay = 0;
	($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time);
	$Mond = $mon;
	$YearC = $year + 1900;
	if($MonSw eq 0){
		$ChkDay = $mday;
		$Mond += 1;
	}elsif(($MonSw > 0) && (($mon + $MonSw) > 11)){
		$YearC += 1;
		$Mond += $MonSw - 11;
	}elsif(($MonSw < 0) && (($mon + $MonSw) < 0)){
		$YearC -= 1;
		$Mond += $MonSw + 13;
	}else{
		$Mond += $MonSw + 1;
	}

	if($YearC < 1900){ $YearC += 1900;}
	@monthday = (0,31,28,31,30,31,30,31,31,30,31,30,31);
	$Tmpweek = ($YearC - 1) + int(($YearC - 1) / 4) - int(($YearC - 1) / 100) + int(($YearC - 1) / 400);
	if($YearC % 400 eq 0 || ($YearC % 100 ne 0 && $YearC % 4 eq 0)) {
		$monthday[2] = 29;
	}
	($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time - $start_date * 86400);
	$YearBk = $year + 1900;
	$MondBk = $mon;
	$DayBk  = $mday;
	if($YearBk < 1900){ $YearBk += 1900;}
	$MondBk += 1;
	($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time + 86400);

	$YearFk = $year + 1900;
	$MondFk = $mon;
	$DayFk  = $mday;
	if($YearFk < 1900){ $YearFk += 1900;}
	$MondFk += 1;
	$TmpDay = 0;
	for($i=1; $i < $Mond; $i++){
		$TmpDay += $monthday[$i];
	}
	$Weekd = ($Tmpweek + ($TmpDay % 7)) % 7;
	if($Weekd > 5) {
		$Weekd = 0;
	}else{
		$Weekd += 1;
	}
	$Tday = int(20.8431 + 0.242194 * ($YearC - 1980) - int(($YearC - 1980) / 4));
	$WeekDayM[0] = "-1,3,$Tday,-1,春分の日";
	$Tday = int(23.2488 + 0.242194 * ($YearC - 1980) - int(($YearC - 1980) / 4));
	$WeekDayM[1] = "-1,9,$Tday,-1,秋分の日";
	$Tmpweek = ($YearC - 1) + int(($YearC - 1) / 4) - int(($YearC - 1) / 100) + int(($YearC - 1) / 400);
	if($YearC % 400 eq 0 || ($YearC % 100 ne 0 && $YearC % 4 eq 0)) {
		$monthday[2] = 29;
	}
	$TmpDay = 0; $HitDay = 0; $OutStr = "";
	for($i=1; $i < $Mond; $i++){ $TmpDay += $monthday[$i]; }
	$Weekd = ($Tmpweek + ($TmpDay % 7)) % 7;

	if($Weekd > 5) { $Weekd = 0; }
	else{ $Weekd += 1; }
	$OutStr .= "<TABLE BORDER=0 style='font-size: 9pt;' width=150>";
	$OutStr .= "<TR><TD COLSPAN=7 BGCOLOR='#DDDDDD' nowrap valign=top>";
	$OutStr .= "<DIV ID='statview" . $Mond . "' style='width:142px;font-size:9pt;'>" . $YearC . "年" . $Mond . "月</DIV>";
	$OutStr .= "</TD></TR>";
	$OutStr .= "<TR BGCOLOR='#EEEEEE' align=center><TD BGCOLOR='#FFCCCC'>日</TD>";
	$OutStr .= "<TD>月</TD><TD>火</TD><TD>水</TD><TD>木</TD><TD>金</TD>";
	$OutStr .= "<TD BGCOLOR='#CCCCFF'>土</TD></TR>";
	if($Weekd > 0){
		$OutStr .= "<TR BGCOLOR='#FFFFFF' ALIGN=center>";
		for($i=0; $i < $Weekd; $i++){
			$OutStr .= "<TD><FONT COLOR='#FFFFFF'>&nbsp;</FONT></TD>";
		}
	}
	$furDay = 0;	$MonCnt = $HitKday = 0;
	for($j=1; $j <= $monthday[$Mond]; $j++){
		$HitSday = 0; $WeeDtg = "";
		$Weektmp = ($Weekd + $j -1 ) % 7;
		if($Weektmp eq 1){ $MonCnt++; }
		if($Weektmp eq 0){ $OutStr .= "<TR BGCOLOR='#FFFFFF' ALIGN=center>"; }
		$WeekDayM_lengh = @WeekDayM;
		for($wi=0; $WeekDayM_lengh > $wi; $wi++){
			($YerT, $MonT, $WeeT, $WsmT, $WedT) = split(/\,/, $WeekDayM[$wi]);
			if(($YerT eq -1) && ($MonT eq $Mond) &&
				(($WeeT eq $j) ||
				(($WeeT eq -1) && ($WsmT eq $MonCnt) && ($Weektmp eq 1)))){
				$WeeDtg = $WedT;
				$HitSday = $HitKday = 1;
				last;
			}
			if(($YerT eq $YearC) && ($MonT eq $Mond) && ($WeeT eq $j)){
				$WeeDtg = $WedT;
				$HitSday = 1;
				last;
			}
		}
		if(($HitSday ne 1) && ($HitKday eq 1) && ($Weektmp ne 0)){	
			$dj = $j + 1;
			$Weektmpd = ($Weekd + $dj -1 ) % 7;
			for($wi=0; $WeekDayM_lengh > $wi; $wi++){
				($YerT, $MonT, $WeeT, $WsmT, $WedT) = split(/\,/, $WeekDayM[$wi]);
				if(($YerT eq -1) && ($MonT eq $Mond) && ($WeeT eq $dj)){
					$WeeDtg = '国民の休日';
					$HitSday = 1;
					last;
				}
			}
			$HitKday = 0;
		}
		if($HitSday eq 1){
			if($Weektmp eq 0){ $furDay = 1; }
			$OtStrTp = "<TD BGCOLOR='#FFCCCC'";
		}else{
			if($furDay eq 1){
				$WeeDtg = "振替休日";
				$OtStrTp = "<TD BGCOLOR='#FFCCCC'";
				$furDay = 0;
			}elsif($Weektmp eq 0){
				$OtStrTp = "<TD BGCOLOR='#FFCCCC'";
			}elsif($Weektmp eq 6){
				$OtStrTp = "<TD BGCOLOR='#CCCCFF'";
			}else{
				$OtStrTp = "<TD";
			}
		}
		if($j eq $ChkDay){
			$OtStrTp = "<TD BGCOLOR='#AAFF55'";
		}
		$OutStr .= $OtStrTp;

		$fmtDate = sprintf("%04d%02d%02d", $YearC, $Mond, $j);
		$Outcapt = $YearC . "年" . $Mond . "月" . $j .  "日" . "(" . $youbi[$Weektmp] . ") " . $WeeDtg;
		if($WeeDtg ne ""){
			$Outcapt1 = $Mond . "月" . $j .  "日" . " " . $WeeDtg;
		}else{
			$Outcapt1 = $Mond . "月" . $j .  "日" . "(" . $youbi[$Weektmp] . ")";
		}
		$Outcapt2 = $YearC . "年" . $Mond . "月";

		unless($brtype eq 1){
			$OutStr .= " onMouseOver=\"document.all.statview" . $Mond . ".innerHTML='" . $Outcapt1 . "'; window.status='" . $Outcapt . "'; return true;\"";
			$OutStr .= " onFocus=\"document.all.statview" . $Mond . ".innerHTML='" . $Outcapt1 . "'; window.status='" . $Outcapt . "';return true;\"";
			$OutStr .= " onMouseOut=\"document.all.statview" . $Mond . ".innerHTML='" . $Outcapt2 . "'; window.status=''; return true;\"";
		}

		$OutStr .= ">";
		if((($YearBk < $YearC) || (($YearBk eq $YearC) && (($MondBk < $Mond) || (($MondBk eq $Mond) && ($DayBk < $j))))) && (($YearFk > $YearC) || (($YearFk eq $YearC) && (($MondFk > $Mond) || (($MondFk == $Mond) && ($DayFk > $j)))))){
			$OutStr .= "<A HREF=\"JavaScript:click_day('" . $fmtDate . "')\">";
			$OutStr .= "<b>" . $j . "</b></A></TD>";
			$HitDay = 1;
		}else{
			$OutStr .= "<font color='#bbbbbb'>" . $j . "</font></TD>";
		}
		if($Weektmp == 6){
			$OutStr .= "</TR>";
		}
	}
	if($Weektmp < 6){
		for($i=$Weektmp; $i < 6; $i++){
			$OutStr .= "<TD><FONT COLOR='#FFFFFF'>&nbsp;</FONT></TD>";
		}
		$OutStr .= "</TR>";
	}
	$OutStr .= "</TABLE>";
	if($HitDay eq 1){ return $OutStr; }

}

sub get_epg_db{
    local($request) = @_;
    $request =~ /(\d{2})(\d{2})(\d{2})-(\d{2})(\d{2})(\d{2})-\d{6}-(\d{2})/;
    my $start_time = "20".$1."-$2-$3 $4:$5:$6";
    my $chan = $7;
    my $sql = <<END;
select
    dc_name,dv_name,dv_text 
    from
    da_event e inner join da_channel c 
    on
    e.dv_service_id = c.dc_service_id 
    where
    e.dv_start_time = ? and c.dc_ch = ?
END
;#
    my $dsn = 'DBI:SQLite:dbname='.$DBNAME;
    my $dbh = DBI->connect($dsn, undef, undef, {RaiseError => 1, AutoCommit => 0});
    my $sth = $dbh->prepare($sql);
    my $rv = $sth->execute($start_time, $chan);
    my $ref = $sth->fetch();
    $sta=$$ref[0];
    $TitleI=$$ref[1];
    $TitleSI=$$ref[2];
    undef $sth;
    $dbh->disconnect();	
}

sub ttnres {
    my($msg) = @_;
    $msg =~ /sdate=([0-9][0-9][0-9][0-9])([0-9][0-9])([0-9][0-9])/;
    my $date = "$1-$2-$3";
    my $dYear = $1;    my $dMon = $2;    my $dDay = $3;
    my $glbSO = "";
    my $table_today = 0;
    my $now_epoch = time()-$startH*3600;
    if ($date eq "--") {
	my @tm = localtime($now_epoch);
	$dYear = $tm[5]+1900;
	$dMon = $tm[4]+1;
	$dDay = $tm[3];
	$date = sprintf("%04d-%02d-%02d", $dYear, $dMon, $dDay);
    }
    my $OCache = $CacheDir."/".$date.".tab";
    my $dl_epoch = timelocal(0,0,$startH,$dDay,$dMon-1,$dYear-1900)+86400;
    if($now_epoch - $dl_epoch > 0){
	&expire_file($CacheDir, 'tab', 'CacheLockTimeT', $ExpireCache * 3600);
	$glbSO=&read_cache($OCache,'CacheLockTimeT');
    }else{
	 $table_today = 1;
    }
    if($glbSO eq ""){
    my $dsn = 'DBI:SQLite:dbname='.$DBNAME;
    my $dbh = DBI->connect($dsn, undef, undef, {RaiseError => 1, AutoCommit => 0});
   
    $glbSO .= "<div class='ttbl'><table>\n";
    my $tabHead=<<END;
    <tr>
    <th scope = \"row\" style="width:20px"><br></th>
END
	
my $sql = <<END;
select
    dc_id,
    dc_name
    from
    da_channel
    order by
    dc_id
END
	
    my $sth = $dbh->prepare($sql);
    my $rv = $sth->execute();
    
    my @channel = ();
    
    while (my $ref = $sth->fetch()) {
	my($dc_id, $dc_name) = @$ref;
	
	push(@channel, $dc_id);
	
	$tabHead .= "<th scope=\"row\"><a href=\"http://www.google.co.jp/search?hl=ja&btnI=1&q=$dc_name\">$dc_name</a></th>";
#simple#	$tabHead .= "<th scope=\"row\">$dc_name</th>";
    }
    
    $tabHead .= "</tr>\n";
    $glbSO .= $tabHead;
	
$sql = <<END;
select
    p.dv_id,
    p.dv_name,
    p.dv_text,
    
    (select
     g1.mg_name
     from
     da_genre g
     left outer join
     ma_genre1 g1
     on
     g1.mg_level1 = g.mg_level1
     where
     g.dv_id = p.dv_id
     order by
     g.dg_id
     limit
     1
    ),
	 
     c.dc_id,
     c.dc_ch,
     
     strftime('%s', p.dv_start_time),
     strftime('%s', datetime(p.dv_start_time, p.dv_duration)),
     strftime('%Y%m%d-%H%M%S', p.dv_start_time),
     strftime('%H%M%S', datetime(p.dv_start_time, p.dv_duration)),
     strftime('%H', p.dv_start_time),
     strftime('%M', p.dv_start_time),
     
     julianday(p.dv_start_time) - julianday(?),
     p.dv_start_time <= datetime('now', 'localtime'),
     datetime('now', 'localtime') < datetime(p.dv_start_time, p.dv_duration)
     
     from
     da_event p
     inner join
     da_channel c
     on
     c.dc_network_id = p.dv_original_network_id
     and
     c.dc_service_id = p.dv_service_id
     where
     c.dc_id = ?
     and
     datetime(?, ?) < datetime(p.dv_start_time, p.dv_duration)
     and
     p.dv_start_time < datetime(?, ?)
     order by
     p.dv_start_time
END
undef $sth;
    my $sth = $dbh->prepare($sql);
    
    my $program = {};
    my $endH = $startH+24;
    my $d_epoch = timegm(0,0,$startH,$dDay,$dMon-1,$dYear-1900);
    
    foreach my $dc_id (@channel) {
	my $rv = $sth->execute($date, $dc_id, $date,"$startH hours", $date,"$endH hours");
	
	my $oHour = $startH;
	my $oMinute = 0;
	
	while (my $ref = $sth->fetch()) {
	    my(	$dp_id,
		$dp_title,
		$dp_desc,
		$dt_name,
		$dc_id,
		$dc_ch,
		$start_epoch,
		$end_epoch,
		$start,
		$end,
		$hour,
		$minute,
		$days,
		$onair,
		$recording,
		) = @$ref;
	    
 	    my $duration;
 	    my $iHour;
 	    my $iMinute;
 	    if($start_epoch < $d_epoch){
 		$iHour = $startH;
 		$iMinute = 0;
 		$duration = int($end_epoch / 60) - int($d_epoch / 60);
 	    }else{
		$iHour=$hour = int($hour + int($days) * 24);
		$iMinute=$minute = int($minute);
		if($end_epoch > $d_epoch+86400){
		    $duration = int($d_epoch / 60)+1440 - int($start_epoch / 60);
		}else{
		    $duration = int($end_epoch / 60) - int($start_epoch / 60);
		}
		&dummy_program(\$oHour, \$oMinute, $hour, $minute, $dc_id);
	    }
	    $program->{$dc_id}->{$iHour}->{$iMinute} = [
		$dp_id,
		$dp_title,
		$dp_desc,
		$dt_name,
		$dc_id,
		$dc_ch,
		$start,
		$end,
		$hour,
		$minute,
		$duration,
		$onair,
		$recording,
		];
	    
	    $oMinute += $duration;
	    
	    while (60 <= $oMinute) {
		$oMinute -= 60;
		$oHour++;
	    }
	}
	
	&dummy_program(\$oHour, \$oMinute, $endH, 0, $dc_id);
    }
sub dummy_program {
	my($oHour, $oMinute, $hour, $minute, $dc_id) = @_;
	if ($$oHour != $hour || $$oMinute != $minute) {
		my $tHour = $hour;
		my $tMinute = $minute;

		my $oDuration = $tMinute - $$oMinute;

		while ($oDuration < 0) {
			$oDuration += 60;
			$tHour--;

			if ($tHour < 0) {
				$tHour += 24;
			}
		}

		my $pHour = $tHour - $$oHour;

		while ($pHour < 0) {
			$pHour += 24;
		}

		$oDuration += 60 * $pHour;

		$program->{$dc_id}->{$$oHour}->{$$oMinute} = [
			undef,
			undef,
			undef,
			undef,
			undef,
			undef,
			undef,
			undef,
			undef,
			undef,
			$oDuration,
			undef,
			undef,
		];

		$$oMinute += $oDuration;

		while (60 <= $$oMinute) {
			$$oMinute -= 60;
			$$oHour++;
		}
	}
}
    
    
    for (my $iHour = $startH; $iHour < $endH; $iHour++) {
	
	for (my $iMinute = 0; $iMinute < 60; $iMinute++) {
	    $glbSO .= "<tr>";
	    
	    if ($iMinute == 0) {
		$glbSO .= sprintf("<th rowspan=60>%d</th>\n", $iHour % 24);
	    }
	    
	    foreach my $dc_id (@channel) {
		if (defined $program->{$dc_id}->{$iHour}->{$iMinute}) {
		    my(
			$dp_id,
			$dp_title,
			$dp_desc,
			$dt_name,
			$dc_id,
			$dc_ch,
			$start,
			$end,
			$hour,
			$minute,
			$duration,
			$onair,
			$recording,
			) = @{$program->{$dc_id}->{$iHour}->{$iMinute}};
		    
		    if (!$dp_id) {
			$glbSO .= "<td rowspan=$duration class=bgNone><br></td>\n";
			next;
		    }
		    
		    my $rs_id = 2;
		    my $start_time = sprintf('%d:%02d', $hour % 24, $minute);
		    if ($onair) {
			if ($recording) {
			    $rs_id = 1;
			    $table_today=1;
			} else {
			    $rs_id = 0;
			}
			if($icon_enable){
#			    $dp_title =~ s/\[(.*?)\]/<img src=\"img\/$title_icon{$1}\.gif\" width=13 height=13 alt=$1>/g;
			    $dp_title =~ s/\[(.*?)\]/<img src=\"img\/$title_icon{$1}\.gif\" width=13 height=13>/g;
 			    &TitleSI_icon(\$dp_desc);
			}
			my $link = join('-', substr($start, 2), $end, $dc_ch);
			if($OpenNewWindow eq 1){
			    $dp_title = "<a href='?site=007&request=$link'  onclick='var wo = window.open(this.href,\"view_w\", \"toolbar=no,directories=no,scrollbars=no,resizable=no,menubar=no,width=320,height=240\");wo.resizeTo(320,240);wo.focus();return false;'><b><strong>$dp_title</strong></b></a>";
			}else{
			    $dp_title = "<a href=\"?site=007&request=$link\"><b><strong>$dp_title</strong></b></a>";
			}
		    }
		    my $desc = '';
		    
		    if ($dp_desc ne '' && $tt_desc_enable) {
			$desc .= "$dp_desc";
		    }
		    
		    if ($dt_name ne '' && $tt_genre_enable) {
			$desc .= "<div align=right>($dt_name)</div>";
		    }
		    
		    $glbSO .= "<td valign=top rowspan=$duration ";
		    $sumimg = "";
		    if(!$rs_id){
			switch($dt_name){
			    case /アニメ/ {
				$glbSO .= "class=bgAnime";
			    }
			    case /ドラマ/ { 
				$glbSO .= "class=bgDrama";
			    }
			    case /音楽/ { 
				$glbSO .= "class=bgMusic";
			    }
			    case /スポーツ/ {
				$glbSO .= "class=bgSports";
			    }
			    case /映画/ {
				$glbSO .= "class=bgMovie";
			    }
			}
			$imglink = join('-', substr($start, 2), 'xxxxxx', $dc_ch);
			if($Thumb eq 1){
				if(-e "$ThmDir/$imglink.jpg"){
					$sumimg = "<img border=0 src='$Thm_URL/$imglink.jpg' width=107 height=60><br>";
				}else{
					$sumimg = "<img border=0 src='img/blank.jpg' width=107 height=60><br>";
				}
			}
			if($IkioiGraph eq 1 || $IkioiRes eq 1){
				$sumimg .= &per_graph("$imglink.txt");
			}

		    }else{
			switch($rs_id){
			    case 1 {
				$glbSO .= "class=bgRecording";
			    }
			    case 2 {
				$glbSO .= "class=bgNone";
			    }
			}
		    }


		    $glbSO .= ">$sumimg<b>$start_time</b>\n$dp_title$desc</td>";
		}
	    }
	    $glbSO .= "</tr>";
	}
        $glbSO .= "\n";
    }
    undef $sth;    
    $dbh->disconnect();
    $glbSO .= $tabHead;
    $glbSO .= <<END;
</table></div>
END
	if($table_today==0){
	    &cache_write($glbSO, 'CacheLockTimeT', $OCache);
	    utime($dl_epoch,$dl_epoch,$OCache);
	}
    }
    print $glbSO;
}

sub nres{
    local($msg,$mode)=@_;

    @wday = ('日','月','火','水','木','金','土');
    %genre1code=('G',5,'B',3,'C',6,'I',7,'M',8,'H',10,
		'K',2,'J',0,'E',9,'F',4,'D',1,'L',11);
    %genre2code=('G1',3,'G2',0,'G3',2,
		 'BA',0,'BB',1,'BC',2,
		 'CA',0,'CB',1,'CC',2,
		 'IA',0,'IB',1,'IC',2,
		 'MA',0,'MB',1,'MC',2,'MD',3,'ME',4,'MI',8,
		 'HA',0,'HB',0,'HD',3,'HE',1,'HI',5,'HJ',6,
		 'KA',0,'KF',5,'KH',7,
		 'JA',0,'JB',1,'JD',4,'JE',5,'JH',8,'JI',9,
		 'EB',3,'EA',4,'ED',1,
		 'FA',0,'FB',1,'FE',4,'FF',5,'FG',6,'FH',7,
		 'DE',0,'D2',1,'D1',2,'D4',5,'D3',3,'DI',10);
    my $sqlS = <<END;
select
    strftime('%s',dv_start_time),
    strftime('%s',dv_start_time,dv_duration),
    dc_ch,
    dc_name,
    (select
     g2.mg_name
     from
     da_genre g
     left outer join
     ma_genre2 g2
     on
     g2.mg_level1 = g.mg_level1
     and
     g2.mg_level2 = g.mg_level2
     where
     g.dv_id = e.dv_id
     order by
     g.dg_id
     limit
     1
    ),
    dv_name,
    dv_text
    from    da_event e inner join da_channel c 
    on    e.dv_service_id = c.dc_service_id 
    where   ( e.dv_name like ? or e.dv_text like ? ) 
    and 
    e.dv_start_time BETWEEN ? AND datetime(?,?)
    ORDER BY e.dv_start_time
END
    my $sqlG=<<END;
select
    strftime('%s',dv_start_time),
    strftime('%s',dv_start_time,dv_duration),
    dc_ch,
    dc_name,
    (select g2.mg_name 
     from ma_genre2 g2
     where g.mg_level1 = g2.mg_level1 and g.mg_level2=g2.mg_level2
    ),
    dv_name,
    dv_text
    from 
    (
     da_event e inner join da_channel c 
     on
     e.dv_service_id = c.dc_service_id
    ) inner join da_genre g 
    on e.dv_id = g.dv_id
    where (e.dv_start_time BETWEEN ? AND datetime(?,?)) and
END
;#
    if($mode eq ""){
	$chnam = time;
    }else{
	$chnam = $mode;
    }
    &expire_file($CacheDir, 'txt', 'CacheLockTimeT', $ExpireCache * 3600);
    $OCache = $CacheDir . "\\" . $chnam . '.txt';
    $resbuf = &read_cache($OCache, 'CacheLockTimeTS');
    if($resbuf eq ""){
	if($msg eq ""){
	    &htmlhead();
	    print "有効期限切れです\n";
	    exit(0);
	}else{
	    $msg =~ /sdate=(\d{4})(\d{2})(\d{2})&/;
	    my $start_time= sprintf("%s-%s-%s %02d:00:00",$1,$2,$3,$startH);
	    $msg =~ /ldate=(\d*)&/;	    
	    my $ldate = $1." day";
	    if($msg =~ /key=(.*)/ && $1 ne ""){
		my $sstr = $1;
		$sstr =~ s/'/''/g;
		$sstr =~ s/\\/\\\\/g;
		$sstr = "%".$sstr."%";
		@execdim = ($sstr,$sstr,$start_time,$start_time,$ldate);
		$sql=$sqlS;
	    }elsif($msg =~ /genre=(.*?)&/ && $1 ne ""){
		my $genre_str=$1; $genre_str =~ s/%7C/|/g;
		$genre_str =~ s/([GBCIMHKJEFDL])\./ g.mg_level1=$genre1code{$1} /g; 
		$genre_str =~ s/(([GBCIMHKJEFD])[1-4A-J])/\(g.mg_level1=$genre1code{$2} and g.mg_level2=$genre2code{$1}\)/g; 
		$genre_str =~ s/\|/OR/g;
		$genre_str = '('.$genre_str.')';
		@execdim = ($start_time,$start_time,$ldate);
		$sql = $sqlG.$genre_str." GROUP BY e.dv_id ORDER BY e.dv_start_time";
	    }else{
		&htmlhead();
		print "検索条件不正";
#		print "<br>msg = ",$msg,"<br>";
		exit(0);

	    }
#	    &htmlhead();
#	    print "デバッグ";
#	    print "<br>SQL = ",$sql,"<br>";
#	    exit(0);

	    my $dsn = 'DBI:SQLite:dbname='.$DBNAME;
	    my $dbh = DBI->connect($dsn, undef, undef, {RaiseError => 1, AutoCommit => 0});
	    my $sth = $dbh->prepare($sql);
	    my $rv = $sth->execute(@execdim);

	    $rRecC=0;
	    $glblO="";
	    $IBUFs="";
	    while(my $ref = $sth->fetch()){
#   (0:sec, 1:min, 2:hour, 3:mday, 4:mon, 5:year,6:wday, 7:yday, 8:isdst)
		@stm=gmtime(int($$ref[0]));
		@etm=gmtime(int($$ref[1]));
		$stm[4]++; $stm[5]-=100;

		$firstline = 
		    sprintf("%d/%d(%s) &nbsp;%d:%02d〜%d:%02d&nbsp; (%s/%s)",
			    $stm[4],$stm[3],$wday[$stm[6]],$stm[2],$stm[1],
			    $etm[2],$etm[1],$$ref[3],$$ref[4]);
		$request = 
		    sprintf("%02d%02d%02d-%02d%02d%02d-%02d%02d%02d-%02d",
			    $stm[5],$stm[4],$stm[3],$stm[2],$stm[1],$stm[0],
			    $etm[2],$etm[1],$etm[0],
			    $$ref[2]);
		$TitleI  = $$ref[5];
		$TitleSI = $$ref[6];


		$stday = sprintf("%02d/%02d/%02d",$stm[5],$stm[4],$stm[3]);
		$stim  = sprintf("%02d:%02d:%02d",$stm[2],$stm[1],$stm[0]);
		$etim  = sprintf("%02d:%02d:%02d",$etm[2],$etm[1],$etm[0]);
		$ch = $$ref[2];

                if($stm[5]>8){ # just in case
		$resbuf .= 
		    $firstline .",".
		    $request .",".
		    $TitleI .",".
		    $TitleSI .",".
		    $stday .",".
		    $stim .",".
		    $etim .",".
		    $ch ."\n"; 
                } 
	    }
	    undef $sth;
	    $dbh->disconnect();	
	    if($chnam ne 'none'){
		&cache_write($resbuf, 'CacheLockTimeTS', $OCache);
	    }
	}
    }
    $nRecC=0;
    foreach $RecS (split(/\n/,$resbuf)){
	($firstline ,
	 $request,
	 $TitleI,
	 $TitleSI,
	 $stday,
	 $stim,
	 $etim,
	 $ch) = split(/,/,$RecS);
	if($icon_enable){
	    $TitleI =~ s/\[(.*?)\]/<img src=\"img\/$title_icon{$1}\.gif\" width=\"13\" height=\"13\" alt=\"$1\">/g;
#	    $TitleSI =~ s/\【(.*?)\】/<img src=\"img\/$desc_icon{$1}\.gif\" width=\"13\" height=\"13\" alt=\"$1\">/g;
 	    &TitleSI_icon(\$TitleSI);
	}
	$Eomsgid=$request;
	$lbtsname = $mp4_folder . "\\" . $request;
	$lerrname = $log_folder . "\\" . $request . ".err";
	$breakB =  "&nbsp;<a href='?cachename=$chnam&abort=$Eomsgid'><nobr>「中断」</nobr></a>";
	$recok = &jg_recdate($Eomsgid);
	if($recok eq 1){
		$get_Tj = $Thumb + $IkioiGraph + $IkioiRes;
		$sumimg = "";
		if($get_Tj ne 0){
			$rstday = $stday; $rstday =~ s:/::g;
			$rstim = $stim; $rstim =~ s/://g;
			$imglink = join('-', $rstday, $rstim, 'xxxxxx', $ch);
			$sumimg = "<tr><td><table border=0 class='nres'>";
		}
		if($Thumb eq 1){
			if(-e "$ThmDir/$imglink.jpg"){
				$sumimg .= "<td><img border=0 src='$Thm_URL/$imglink.jpg' width=107 height=60></td>";
			}else{
				$sumimg .= "<td><img border=0 src='img/blank.jpg' width=107 height=60></td>";
			}
		}
		if($IkioiGraph eq 1 || $IkioiRes eq 1){
			$graphM = &per_graph("$imglink.txt");
			if($graphM ne ""){
				$sumimg .= '<td width=106 height=60 bgcolor=#bbbbbb align=center nowrap>' . $graphM . '</td>';
			}
		}
		if($get_Tj ne 0){
			$IBUFs = "$sumimg</table>$firstline<br>\n";
		}else{
			$IBUFs = "<tr><td>$firstline<br>";
		}
	}else{

		$IBUFs = "<tr><td><font color=#999999>$firstline<br>";
	}
	if($recok ne -2){
		if($OpenNewWindow eq 1){
		    $IBUFs .= "<a href='?site=007&request=$request' onclick='var wo = window.open(this.href,\"view_w\", \"toolbar=no,directories=no,scrollbars=no,resizable=no,menubar=no,width=320,height=240\");wo.resizeTo(320,240);wo.focus();return false;'><b>$TitleI</b></a>";
		}else{
		    $IBUFs .= "<a href='?site=007&request=$request'><b>$TitleI</b></a>";
		}
	}else{
		$IBUFs .= "<b><font color=#999999>$TitleI</font></b>";
	}
	if($tt_desc_enable eq 1){
	    $IBUFs .= "<br>$TitleSI";
	}
	if(-f "$lerrname"){
	    $glblO .= "<tr>" . $IBUFs . "<td align=center colspan=2>";
	    $glblO .= "■MP4作成に失敗しました";
	}elsif(-f "$lbtsname.np99"){
	    $glblO .= "<tr>" . $IBUFs . "<td align=center colspan=2>";
	    $glblO .= "■他の番組を抽出中です。順番待ちをしています$breakB";
	}else{
	    unless(($FBCI{$nRecC} eq "") || (($FBCI{$nRecC} eq 'p') && (-f "$lbtsname.mp4")) || (($FBCI{$nRecC} eq 'i') && (-f "$lbtsname$RwIPOD.mp4"))){
		$glblO .= "<tr>" . $IBUFs . "<td align=center colspan=2>";
		unless(-f "$lbtsname.np"){
		    unless(-f "$lbtsname.np99"){	# 順番待ち
			if($FBCI{$nRecC} eq 'p'){
			    $MkMode= 0;
			}else{
			    $MkMode= 1;
			}
			$PofPerl = $^X;
			Win32::Process::Create($ProcessObj, $PofPerl,"$PofPerl encode.pl $lbtsname $lerrname $stday $stim  $etim $ch $MkMode", 0, DETACHED_PROCESS, ".");
			$glblO .= "■エンコードを開始しています$breakB";
		    }else{
			$glblO .= "■他の番組を抽出中です。順番待ちをしています$breakB";
		    }
		}else{
		    $Rmsg = &status_vs($lbtsname, "nouri") . $breakB;
		    $glblO .= "<font color='red'>" . $Rmsg . "</font>";
		}
	    }else{
		$Rmsg = &status_vs($lbtsname, "nouri");
		if($Rmsg ne ""){
		    $glblO .= "<tr>" . $IBUFs . "<td align=center colspan=2>";
		    $glblO .= "<font color='red'>" . $Rmsg . $breakB  . "</font>";
		}elsif($recok eq -1){
		    $glblO .= "<tr>" . $IBUFs . "<td align=center colspan=2>";
		    $glblO .= "■現在録画中です";
		}elsif($recok eq -2){
		    $glblO .= "<tr>" . $IBUFs . "<td align=center colspan=2>";
		    $glblO .= "■まだ録画していません";
		}else{
		    $TitleIEnc = "";
		    if($brtype eq 1){
			$glblO .= "<tr>" . $IBUFs . "<td align=center colspan=2>";
		    }else{
			if($RwIPOD ne ""){
			    $glblO .= "<tr>" . $IBUFs . "<td align=center width=97>";
			}else{
			    $glblO .= "<tr>" . $IBUFs . "<td align=center colspan=2>";
			}
			if(-f "$lbtsname.mp4"){
 			    &get_epg_db($lbtsname);
			    $TitleIEnc = &mkFname($TitleI, $Eomsgid, $sta);
			    $fisz = (-s "$lbtsname.mp4");
			    $fisz = int($fisz / 1024 / 1024);
			    $glblO .= "<a href='download.pl?$Eomsgid.mp4&$TitleIEnc%2Emp4'>PC用 ($fisz" . "MB)</a>";
			}else{
			    $glblO .= "<input type='checkbox' name='bc' value='$nRecC'>";
			}
			if($RwIPOD ne ""){
			    $glblO .= "</td><td align=center width=97>";
			}
		    }
		    if($RwIPOD ne ""){
			if(-f "$lbtsname$RwIPOD.mp4"){
			    $fisz = (-s "$lbtsname$RwIPOD.mp4");
			    $fisz = int($fisz / 1024 / 1024);
			    if($brtype eq 1){
				$glblO .= "<a href='$mp4_URL$Eomsgid$RwIPOD.mp4'> iPod用($fisz" . "MB)</a>";
			    }else{
				$glblO .= "<a href='download.pl?$Eomsgid.mp4&$TitleIEnc$RwIPOD%2Emp4&$RwIPOD'> iPod用($fisz" . "MB)</a>";
			    }
			}elsif((-f "$lbtsname.mp4") && ($iencM{$ch} eq 0)){
			    $fisz = (-s "$lbtsname.mp4");
			    $fisz = int($fisz / 1024 / 1024);
			    if($brtype eq 1){
				$glblO .= "<a href='$mp4_URL$Eomsgid.mp4'> iPod用($fisz" . "MB)</a>";
			    }else{
				$glblO .= "<a href='download.pl?$Eomsgid.mp4&$TitleIEnc$RwIPOD%2Emp4'> iPod用($fisz" . "MB)</a>";
			    }
			}else{
			    $glblO .= "<input type='checkbox' name='bci' value='$nRecC'>";
			}
		    }
		}
	    }
	}
	$glblO .= "</td></tr>\n";
	$nRecC++;
    }
    &htmlhead("640");
    print '<body>';
    if($glblO ne ""){
	$headt = <<"_EOD_";
<script language='JavaScript'>
function ChkChg(CheckStat, ObjName){
    var i;
    if(CheckStat == true){
	eval("for(i = 0; i < document.chkbat." + ObjName + ".length; i++){ document.chkbat." + ObjName + "[i].checked = true; }");
    }else{
	eval("for(i = 0; i < document.chkbat." + ObjName + ".length; i++){ document.chkbat." + ObjName + "[i].checked = false; }");
    }
}
</script>
<table border=1 bordercolor='#999999' cellspacing=0 cellpadding=3 style="font-size: 9pt;" width=100%>
<tr><td bgcolor="#EEAAAA"><table border=0 cellpadding=0 cellspacing=0 width=100% style="font-size: 9pt;"><td>■番組表からの検索結果
</td><td>&nbsp;</td><td align=right><a href='?'>番組検索へ戻る</a></td>
</table>
</td></tr>
<tr><td>
<form method="POST" action="$cginame" name="chkbat">
<div align=right><input type="submit" name="gobatch" value="一括エンコード/最新の情報に更新"></div>
<table border=1 bordercolor='#999999' cellspacing=0 cellpadding=3 class="nres" width=100%>
<tr bgcolor="#EEDDDD" align=center><td rowspan=2>番組名</td><td colspan=2 width=200>MP4作成</tr>
_EOD_
    if($brtype eq 1){
	$headt .= "<tr bgcolor='#EEDDDD'><td align=center colspan=2>(iPod用)<br><input type='checkbox' name='chgstat' onClick='ChkChg(this.checked, \"bci\");'></td></tr>";
    }else{
	if($RwIPOD ne ""){
	    $headt .= "<tr bgcolor='#EEDDDD' align=center><td>(PC用)<br><input type='checkbox' name='chgstat' onClick='ChkChg(this.checked, \"bc\");'></td>";
	    $headt .= "<td>(iPod用)<br><input type='checkbox' name='chgstat' onClick='ChkChg(this.checked, \"bci\");'></td></tr>";
	}else{
	    $headt .= "<tr bgcolor='#EEDDDD'><td align=center colspan=2>(PC用)<br><input type='checkbox' name='chgstat' onClick='ChkChg(this.checked, \"bc\");'></td></tr>";
	}
    }
    print $headt;
    print $glblO;
    print <<"_EOD_";
</table>
<input type="hidden" name="cachename" value="$chnam">
<div align=right><input type="submit" name="gobatch" value="一括エンコード/最新の情報に更新"></div>
</form>
</body>
</html>
_EOD_
    }else{
	print "<font color=\"red\">検索条件に合う番組が見つかりません</font></body></html>";
    }
}
#
sub TitleSI_icon{
    my($SIstr) = @_;
    my %di=%desc_icon;
    while(my($src,$dst)=each(%di)){
	if($$SIstr =~ /【/){ 
	    $$SIstr =~ s/(【$src】)/<img src=\"img\/$dst\.gif\" width=\"13\" height=\"13\" alt=\"$src\" \/>/g;
	}else{last;}
    }
}

sub per_graph(){
	local($g_query) = @_;
	local($graph);
	$graph = "";
	##データを配列に格納。
	if(open(IN,"$IDir/$g_query")){

	while(<IN>){ $file = $_; }
	close(IN); 
        @youso = split(/\,/, $file);
        $chk = $chk2 = $chk3 = 0;
	@resSc = @kitaSc = ();
	$graph = "";
	foreach $n (@youso) {
		if($chk eq "0"){$total=$n;}
		elsif($chk > "0" && $chk <= "20"){ push(@resSc, $n); }	#レス
		elsif($chk eq "22"){ $kita=$n; }
		elsif($chk > 22 && $chk <= 42){ push(@kitaSc, $n); } #キター
		elsif($chk eq "43"){ $length = $n / 60; $ave = sprintf("%.1f",$total/$length); }
		$chk++;
	}

	# レス処理
	@sort_resSc = sort{$a <=> $b} @resSc;
	$high_res = pop(@sort_resSc);
	if($high_res ne 0){
                foreach $n (@resSc) {
			$total_sp[$chk2] = int(($n / $high_res) * 40);
			$chk2++;
		}
	}else{
		for($i=0; $i<=19; $i++){
			$total_sp[$i] = 0;
		}
	}
	# キタ処理
	@sort_kitaSc = sort{$a <=> $b} @kitaSc;
	$high_kita = pop(@sort_kitaSc);
	if($high_kita ne 0){
                foreach $n (@kitaSc) {
			$kita_sp[$chk3] = int(($n / $high_kita) * 40);
			$chk3++;
		}
	}else{
		for($i=0; $i<=19; $i++){
			$kita_sp[$i] = 0;
		}
	}



	unless(($high_res eq 0) && ($high_kita eq 0)){
		#グラフを作る。
		if($IkioiGraph eq 1){
			for($chk4=0; $chk4<=19; $chk4++){
				$graph .="<img src=img/graph1.jpg height=$total_sp[$chk4] width=4><img src=img/graph2.jpg height=$kita_sp[$chk4] width=1>";
			}
			$graph .= "<br>";
		}
		if($IkioiRes eq 1){
			#レス総数(数値)の表示部分。数値によって色を変えています。好みで変更してください。
			#
			$graph .="<font color=#000000>res:</font><font color=";
			if($total >= 5000){$graph .= "#ff0000><b>$total</b></font>";}
			elsif($total >= 4000){$graph .= "#ff0000>$total</font>";}
			elsif($total >= 3000){$graph .= "#dd0000>$total</font>";}
			elsif($total >= 2000){$graph .= "#bb0000>$total</font>";}
			elsif($total >= 1000){$graph .= "#aa0000>$total</font>";}
			elsif($total >=  500){$graph .= "#990000>$total</font>";}
			else{$graph .= "#000000>$total</font>";}

			#1分ごとのレス平均値表示部分。数値によって色を変えています。好みで変更してください。
			$graph .= ",&nbsp;<nowrap><font color=#000000>ave:</font><font color=";
			if($ave >= 500){$graph .= "#ff0000><b>$ave</b>"; }
			elsif($ave >= 200){$graph .= "#ff0000>$ave"; }
			elsif($ave >= 100){$graph .= "#dd0000>$ave"; }
			elsif($ave >=  60){$graph .= "#bb0000>$ave"; }
			elsif($ave >=  30){$graph .= "#aa0000>$ave"; }
			elsif($ave >=  20){$graph .= "#990000>$ave"; }
               		else{$graph .= "#000000>$ave"; }
			$graph .= "</font><font color=#000000></font><br>";
		}
	}
	}
	return $graph;
}

sub jg_recdate {
	local($dtF) = @_;
	local($day, $st_tim, $ed_tim);
	($day, $st_tim, $ed_tim) = split(/-/, $dtF);
	$yy = substr($day,0,2); $mm = substr($day,2,2); $dd = substr($day,4,2);
	$h = substr($st_tim,0,2); $m = substr($st_tim,2,2); $s = substr($st_tim,4,2);
	$stimmin = $h * 3600 + $m * 60;
	$h = substr($ed_tim,0,2); $m = substr($ed_tim,2,2); $s = substr($ed_tim,4,2);
	$etimmin = $h * 3600 + $m * 60;
	if($stimmin > $etimmin){
		$lapt = 86400 + $etimmin;
		$sapt = $stimmin;
	}else{
		$lapt = $etimmin;
		$sapt = $stimmin;
	}
	$fot = timelocal(0,0,0,$dd, $mm-1, $yy);
	$fots = $fot + $sapt;
	$fote = $fot + $lapt;
	$nt = time;
	if($fote > $nt){
		if($fots > $nt){
			return -2;
		}else{
			return -1;
		}
	}else{
		return 1;
	}
}

