﻿#!/perl/bin/perl

use Socket;
use FileHandle;

($arg) = @ARGV;


#1時間前の日付取得
($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time - 3600);

$year += 1900;
$year2 = substr($year,2);
$mon += 1;

if(length($mday) == 2){}else{$mday = "0" . $mday; }
if(length($mon) == 2){}else{$mon = "0" . $mon; }


#現在の日付取得
($sec_now, $min_now, $hour_now, $mday_now, $mon_now, $year_now, $wday_now, $yday_now, $isdst_now) = localtime(time);

if(length($mday_now) == 2){}else{$mday_now = "0" . $mday_now; }
if(length($mon_now) == 2){}else{$mon_now = "0" . $mon_now; }


####################################################################
#設定はここから。
####################################################################



##バッチ登録して定期的にデータ集計させるならこちらのrequestを有効にしてください。
##1時間ごとに実行ならlhourを1。1日ごとに実行するならlhourを24にしましょう。
$request = $year . $mon . $mday . "&shour=" . $hour;

##導入したてorテスト用に本プログラムを実行する場合はこちらのrequestを有効にしてください。
##shourは取得開始時刻。lhourは取得開始時刻より、何時間分取得するかです。たぶん24まで設定可。
#$request ="20100601&shour=1";

##caption.plが動いているサーバ(たぶんこのプログラムを動かしているのと同じサーバ)のＩＰアドレス。
$host2 = '0.0.0.0';

# 番組勢いグラフデータファイル格納ディレクトリ
$IDir = '../OnesegWWW/httpd-doc/ikioi';

# グラフデータファイルの保存期間
$ExpireShot = 41;

####################################################################
#設定たぶんここまで。
####################################################################


&expire_file($IDir, '*', $ExpireShot * 86400);



#処理の説明:MSNから番組表データを取って来る。

print "[START] ".$request. "\n";



# HTTPプロトコルのバージョン
#$http = '1.1';

# デフォルトホストの設定
$host = 'program.tv.jp.msn.com';
$port = getservbyname('http', 'tcp');
$path = '/tv.php?mode=06&site=032&lhour=1&category=sg&template=program&sdate=';
$path .= $request;

# URL解析処理
$arg =~ m!(http:)?(//)?([^:/]*)?(:([0-9]+)?)?(/.*)?!;
if ($3) {$host = $3;}
if ($5) {$port = $5;}
if ($6) {$path = $6;}

$con_host = $host;
$con_port = $port;
$url = $path;

# ソケットの生成
$ip = inet_aton($con_host) || die "host($con_host) not found.\n";
$sockaddr = pack_sockaddr_in($con_port, $ip);
socket(SOCKET, PF_INET, SOCK_STREAM, 0) || die "socket error.\n";

# ソケットの接続
connect(SOCKET, $sockaddr) || die "connect $con_host $con_port error.\n";
autoflush SOCKET (1);


# HTTP要求を送信
if ($http eq '1.1') {
  print SOCKET "GET $url HTTP/1.1\n";
  print SOCKET "Host: $host\n";
  print SOCKET "Connection: close\n\n";

} else {
  print SOCKET "GET $url HTTP/1.0\n\n";
}


#処理の説明:取得したhtmlデータより、<td width=～で始まる行を解析し、番組開始時刻・チャンネルなどをゲットする。


while (chomp($buf=<SOCKET>)) {

                             if($buf =~ /\<td width=\"104\" valign=\"top\" id=/){
$find_s = index ($buf, "&station=");
$find_e = index ($buf, "&mode=");
$get_length = $find_e - $find_s;
$sp_station = substr($buf, $find_s, $get_length);
$sp_station =~ s/&station=//;


    #ご指摘頂いたのに直してない・・・。すみません。
	if($sp_station == "0031"){$sp_station = 27;}
	elsif($sp_station == "0041"){$sp_station = 26;}
	elsif($sp_station == "0004"){$sp_station = 25;}
	elsif($sp_station == "0005"){$sp_station = 22;}
	elsif($sp_station == "0006"){$sp_station = 21;}
	elsif($sp_station == "0007"){$sp_station = 24;}
	elsif($sp_station == "0008"){$sp_station = 23;}
	elsif($sp_station == "0016"){$sp_station = 20;}
	elsif($sp_station == "0009"){$sp_station = 18;}
    else{next;}



$find_s = index ($buf, "&sdate=");
$find_e = index ($buf, "&shour=");
$get_length = $find_e - $find_s;
$sp_YY = substr($buf, $find_s, $get_length);
$sp_YY =~ s/&sdate=//;
$sp_YY = substr($sp_YY,2);

$sp_year  = substr($sp_YY, 0,2);
$sp_mon   = substr($sp_YY, 2,2);
$sp_day   = substr($sp_YY, 4,2);



$find_s = index ($buf, "&shour=");
$find_e = index ($buf, "&lhour=");
$get_length = $find_e - $find_s;
$sp_hour = "";
$sp_hour .= substr($buf, $find_s, $get_length);
$sp_hour =~ s/&shour=//;

if(length($sp_hour) == 2){}else{$sp_hour = "0" . $sp_hour; }

$find_s = index ($buf, "&sminutes=");
$find_e = index ($buf, "&template=");
$get_length = $find_e - $find_s;

$sp_min = substr($buf, $find_s, $get_length);
$sp_min =~ s/&sminutes=//;


$find = index ($buf, "\<\/h2\>");
$ep_hour = substr($buf, $find-5, 2);
$ep_min  = substr($buf, $find-2, 2);


if($ep_min < $sp_min){$length=$ep_min+60-$sp_min;}else{$length=$ep_min-$sp_min;}
if($ep_min < $sp_min){$length_pre =$ep_hour - $sp_hour -1; $length_pre = $length_pre*60; }else{$length_pre =$ep_hour - $sp_hour; $length_pre = $length_pre*60;}

					 if($length_pre <= -1 ){$length=$length+$length_pre+1440;}else{$length=$length+$length_pre;}


#処理の説明:該当する番組の時間帯の字幕データ(.sub)ファイルをcaption.plを利用してgetしてくる。
#(WebサーバでBasic認証などでアクセス制限掛けてるとうまく取って来れないので注意。)


   $length = $length *60;
   $sep= $length / 20;
   $g_query  = "caption.pl?file=";
   $g_query .= $sp_year . $sp_mon . $sp_day . "-" . $sp_hour . $sp_min . "00-" . $ep_hour . $ep_min . "00-" . $sp_station . ".xml";
				
   print "[ch]:" . $sp_station ." [S]:". $sp_year ."/". $sp_mon ."/". $sp_day ."-".  $sp_hour ."-". $sp_min ."  [E]:". xxxxxx ."-". $ep_hour ."-". $ep_min. " [Length(sec)]:".$length." [Sepalate]:".$sep."sec x20\n";

#処理の説明:


# HTTPプロトコルのバージョン
#$http = '1.1';

# デフォルトホストの設定

$port2 = getservbyname('http', 'tcp');
$path2 = '/';
$path2 .= $g_query;

# URL解析処理
$arg =~ m!(http:)?(//)?([^:/]*)?(:([0-9]+)?)?(/.*)?!;
if ($3) {$host2 = $3;}
if ($5) {$port2 = $5;}
if ($6) {$path2 = $6;}

$con_host2 = $host2;
$con_port2 = $port2;
$url2 = $path2;

# ソケットの生成
$ip2 = inet_aton($con_host2) || die "host($con_host2) not found.\n";
$sockaddr2 = pack_sockaddr_in($con_port2, $ip2);
socket(SOCKET2, PF_INET, SOCK_STREAM, 0) || die "socket error.\n";

# ソケットの接続
connect(SOCKET2, $sockaddr2) || die "connect $con_host2 $con_port2 error.\n";
autoflush SOCKET2 (1);


   print "[query]:" . $url2."\n";
#$url2 = 'http://J2lwdTpkbmxkJyAK@' . $host2 . $url2;
#print $url2;
#exit();
# HTTP要求を送信
if ($http eq '1.1') {
 print SOCKET2 "GET $url HTTP/1.1\n";
  print SOCKET2 "Host: $host2\n";
#  print SOCKET2 "Authorization: Basic J2lwdTpkbmxkJyAK\n";
  print SOCKET2 "Connection: close\n\n";

} else {
  print SOCKET2 "GET $url2 HTTP/1.0\n\n";
#  print SOCKET2 "Authorization: Basic J2lwdTpkbmxkJyAK\n\n";
}




#字幕データがあったらレス数とｷﾀｰ数をカウントして、再生時間の20等分(30分番組なら5分ごとの小計)を
#配列に落とし込んでいく。



@total_sep  = ("0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0");
@kita_sep   = ("0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0");

$total=0;$kita=0;
while (chomp($buf2=<SOCKET2>)) {

							 $count="0";
                             if($buf2 =~ /\<p begin/){
                             

							 $res_h= substr($buf2,16,2);
							 $res_m= substr($buf2,19,2);
							 $res_s= substr($buf2,22,2);

							 $res_now= $res_h*60*60;
							 $res_now= $res_now + $res_m*60;
							 $res_now= $res_now + $res_s;

							 $send_sep = sprintf( "%d",$res_now / $sep);

							 #print "\n\n $length @"."$send_sep $res_now".">\n";

							 $count = $buf2;
							 $count = $count =~ s/\<br\/\>//g;

								if($send_sep != 20){
                             
                             						if($count eq ""){$total++; $total_sep[$send_sep]++;
                             						  if($buf2 =~ /キタ/||$buf2 =~ /ktkr/||$buf2 =~ /ｷﾀ/||$buf2 =~ /ww/||$buf2 =~ /ｗｗ/){$kita++;print "k";$kita_sep[$send_sep]++;}else{print "x";}
                                                                 }
                                                    else{
                                                    print "[".$count ."](";

																				@word = split (/\<br\/\>/, $buf2);
																				foreach $n (@word) {
																									#ｷﾀｰ系のカウント。大体こんなキーワードがあればカウントしてます。	
																									if($n =~ /キタ/||$n =~ /ktkr/||$n =~ /ｷﾀ/||$n =~ /ww/||$n =~ /ｗｗ/){$kita++;print "k";$kita_sep[$send_sep]++;}else{print "x";}
																									$total++;$total_sep[$send_sep]++;
																								   }


                                                    print ")";

                                                    }  
                                                    
                             
                             
                             
                             
                                                       
                                                      
                                                }
                                           }
                             }

print "\n\n";

print "[Result]\n total:".$total."res    ";  
foreach $n (@total_sep) {print ",".$n;}print "\n";
print " kita:".$kita ."      ";  
foreach $n (@kita_sep) {print ",".$n;}print "\n";
				




																					

																					#処理の説明:集計結果をファイルに書き込み。以前のデータがあっても新規作成で保存します。

					$output = $IDir . '/';
																																					$output .=$sp_YY;
																					$output .="-";
																					$output .=$sp_hour.$sp_min;
																					$output .="00-xxxxxx-";
																					$output .=$sp_station . ".txt";

print "\n $output \n\n\n";
                             														open(OUT,">$output") || &error("Can't write $output");
                             														print OUT "$total"; foreach $n (@total_sep) {print OUT ",".$n;}print OUT ",zzz,"; print OUT "$kita"; foreach $n (@kita_sep) {print OUT ",".$n;}print OUT ",".$length."\n";
                             														close(OUT);







# 終了処理
close(SOCKET2);



}

}

# 終了処理
close(SOCKET);

sub expire_file {
	($objdir, $objext,  $Expire) = @_;
	opendir(DIB,"$objdir");
	while($DirObj = readdir(DIB)){
		if(($objext eq '*') || ($DirObj =~ /$objext$/)){
			@retval = stat("$objdir\\$DirObj");
			if($retval[9] < (time - $Expire)){
				unlink("$objdir\\$DirObj");
			}
		}
	}
	closedir(DIB);
}

####汚いソースご覧頂きありがとうございました。
####DOSプロンプト上の出力の説明ですが
####xがコメント数。kがｷﾀｰ系と判別されたコメント数。
####.subファイルには同じ秒数帯に複数コメントが< /br>で記載されていることがあるので
####[]は一行に何個レスがあったか。()内はそれぞれのレス解析結果です。