#!/perl/bin/perl

# download.pl 2008/9/12
# TSファイルを生成することなくダウンロード
# 番組名をファイル名に
#
# segwrapperの場所
use lib 'C:\perlrtmp\lib';
use Encode;
#########################################################################
use segwrapper; 
require 'define.pl';
$packet_size = 4096; 

$omsgid = $ENV{'QUERY_STRING'}; 
if ($omsgid eq '') {
	if ($ENV{'PATH_INFO'} ne '') {
		$omsgid = $ENV{'PATH_INFO'};
		$omsgid =~ s/\///g;
	}
}

($msgid, $RFileTmp, $Fext,$ctyp) = split(/&/, $omsgid);
if($Fext ne $RwIPOD){ $Fext = ""; }
$RFileTmp =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
$RFileName = encode('cp932', decode('utf8', $RFileTmp));

$msgid =~ s/[\x00-\x1F]//g; 
($day,$st_tim,$ed_tim,$chtmp)=split(/-/,$msgid); 
($ch, $filler) = split(/\./, $chtmp);
if (($day !~ /^\d{6,6}$/) || ($st_tim !~ /^\d{6,6}$/) || ($ed_tim !~ /^\d{6,6}$/) || ($ch !~ /^\d+$/)) { 
	print "Content-type: text/plain\n\nParameter Error!"; exit();
} 
binmode(STDOUT);
if($msgid =~ /ts$/i){
	$st_tim =~ s/00$/$oftim/;
	$file = $day."-".$st_tim."-".$ed_tim."-".$ch;
	$opt = O_RDONLY | O_BINARY;
	eval { $opt |= O_LARGEFILE; };
	print <<"_EOD_";
Content-Type: video/ts
Content-Disposition: attachment; filename="$RFileName"

_EOD_
	segwrapper::segopen($handle, $file, $opt);
	while(segwrapper::segread($handle, my $buf, $packet_size)) { print $buf; }
	segwrapper::segclose($handle);

}elsif($msgid =~ /bat$/i){
	if($cpUser ne ""){
		$outB = "start $cpName http://$cpUser:$cpPass\@$ENV{'SERVER_NAME'}$mp4_URL$RFileName\n\n";
	}else{
		$outB = "start $cpName http://$ENV{'SERVER_NAME'}$mp4_URL$RFileName\n\n";
	}
	$LENGTH = length($outB);
	print <<"_EOD_";
Content-Length: $LENGTH
Content-Type: application/x-msdownload
Content-Disposition: attachment; filename="open.bat"

_EOD_
	print $outB;
}else{

	$file = $day."-".$st_tim."-".$ed_tim."-".$ch;
	$FSIZE =  (-s "$mp4_folder\\$file$Fext.mp4");
	$RANGE = $ENV{'HTTP_RANGE'};
	($DMY, $RANGE) = split(/=/, $RANGE);
	($DS, $DE) = split(/-/, $RANGE);
	if($DS ne ""){
		$RANGE = $DS;
	}elsif($DE ne ""){
		$RANGE = $DE + 1;
	}else{
		$RANGE = 0;
	}
	if(open(INF, "$mp4_folder\\$file$Fext.mp4")){
		binmode(INF);
		if($ctyp eq "oct"){
			print "Content-Type: application/octet-stream\n";
		}else{
			print "Content-Type: video/mp4\n";
		}
		print "Content-Disposition: attachment; filename=\"$RFileName\"\n";
		$LENGTH = $FSIZE - $RANGE;
		print "Content-Length: $LENGTH\r\n";
		if($RANGE ne 0){
			$RANGES = sprintf("%d-%d/%d", $RANGE, $FSIZE-1, $FSIZE);
			print "Content-range: bytes $RANGES\r\n";
		}else{
			print "Accept-ranges: bytes\r\n";
		}
		print "\r\n";

		if($LENGTH <= $packet_size){
			$packet_size = $LENGTH;
			$LENGTH = 0;
		}else{
			$LENGTH -= $packet_size;
		}
		seek(INF, $RANGE, 0);
		read(INF, $OTBUF, $packet_size);
		while(){
			print $OTBUF;
			if($LENGTH <= 0){ last; }
			if($LENGTH <= $packet_size){
				$packet_size = $LENGTH;
				$LENGTH = 0;
			}else{
				$LENGTH -= $packet_size;
			}
			read(INF, $OTBUF, $packet_size);
		}
		close(INF);
	}
}